<?

// +----------------------------------------------------------------+
// | This Apha Version is Experimental.                             |
// | The behaviour of this Script, the name of its functions,       |
// | and anything else may change without notice in a future        |
// | release of phpMyDir.                                           |
// +----------------------------------------------------------------+

// +----------------------------------------------------------------+
// | phpMyDIR 2.0.alpha -----------| PHP > 4.0.6 -------------------|
// +----------------------------------------------------------------+
// | INFO                                                           |
// |         this script reads a specified dir and                  |
// |         return a array with $folder $file $size $time          |
// |         needs PHP4 or higher                                   |
// |                                                                |
// | AUTHOR & COPYRIGHT (C)                                         |
// |         alexander klein                                        |
// |         http://www.alexanderklein.de                           |
// |         mail@alexanderklein.de                                 |
// |                                                                |
// | RELEASE                                                        |
// |         version 2.0.alpha (31-10-2002)                         |
// |                                                                |
// | THANKS TO                                                      |
// |         carlos pires                                           |
// |             for the option to include more than one extension  |
// |             http://www.osbrasil.org                            |
// |                                                                |
// | CHANGELOG                                                      |
// |         version 2.0 (31-10-2002)                               |
// |             - complete relaunch                                |
// |             - new functions: convert size, time                |
// |                            : set a level to spieder            |
// |                            : switch file information on|off    |
// |                                                                |
// |         version 1.1 (24-02-2002)                               |
// |             - added natcasesort                                |
// |             - added option to include more than one extension  |
// |                                                                |
// |         version 1.0 (24-12-2001)                               |
// |             - first release                                    |
// |                                                                |
// +----------------------------------------------------------------+


/* complete sample with all variables
***************************************************************************************************

//-->-------------------------------------------------------------------->
//--> initalize phpMyDir ------------------------------------------------->
//-->-------------------------------------------------------------------->

include_once(dirname(__FILE__)."/class.phpMyDir.php");

$phpMyDIR = new phpMyDIR;

//-->-------------------------------------------------------------------->
//--> [BASE] ------------------------------------------------------------->
//-->-------------------------------------------------------------------->

    // base root to start the search
    $phpMyDIR->baseRoot = "../";

//-->-------------------------------------------------------------------->
//--> [GLOBAL] ----------------------------------------------------------->
//-->-------------------------------------------------------------------->

    $phpMyDIR->globalDateFormat   = '%d. %B %Y | %H:%M';
    $phpMyDIR->globalDateDays     = array('So', 'Mo', 'Di', 'Mi', 'Do', 'Fr', 'Sa');
    $phpMyDIR->globalDateMonths   = array('Jan', 'Feb', 'Mr', 'Apr', 'Mai', 'Jun', 'Jul', 'Aug', 'Sept', 'Okt', 'Nov', 'Dez');

    $phpMyDIR->globalSizeRound    = 2;
    $phpMyDIR->globalSizeUnits    = array('bytes', 'Kb', 'Mb', 'Gb', 'Tb', 'Pb', 'Eb');

    $phpMyDIR->globalSepThousands = '.';
    $phpMyDIR->globalSepDecimals  = ',';


//-->-------------------------------------------------------------------->
//--> [FILE] ------------------------------------------------------------->
//-->-------------------------------------------------------------------->

    // search for *.html, *.txt, *.php, seperated with comma
    $phpMyDIR->fileMask           = '*.cfg, *.exe, *.jpg, *.html';


    // return the filetime, yes or no
    $phpMyDIR->fileShowTime       = 1; // 0|1

    // convert time into a format like 27-12-2002 14:50
    $phpMyDIR->fileConvertTime    = 1; // 0|1


    // return the filesize, yes or no
    $phpMyDIR->fileShowSize       = 1; // 0|1

    // convert size into a format like 2.800 kb
    $phpMyDIR->fileConvertSize    = 1; // 0|1

//-->-------------------------------------------------------------------->
// [FOLDER] --------------------------------------------------------------->
//-->-------------------------------------------------------------------->

    // spider only for folders, if set to 1, no file will be returned
    $phpMyDIR->folderOnly         = 0; // 0|1

    // return the filetime
    //$phpMyDIR->folderShowTime     = 1; // 0|1

    // convert size into a format like 2.800 kb
    //$phpMyDIR->folderConvertTime  = 1; // 0|1

//-->-------------------------------------------------------------------->
//--> [SPIDER] ----------------------------------------------------------->
//-->-------------------------------------------------------------------->

    // if set to 1, phpMyDIR will spider every subdirecty,
    // until the spiderLevel is reached
    $phpMyDIR->spiderRecursive    = 1; // 0|1

    // level
    $phpMyDIR->spiderLevel        = 2; // 0= no level, 1-???

//-->-------------------------------------------------------------------->
//--> start spidering ---------------------------------------------------->
//-->-------------------------------------------------------------------->

$Result = $phpMyDIR->getResult();

//-->-------------------------------------------------------------------->
//-->-------------------------------------------------------------------->

echo "<table cellpadding='3' cellspacing='3'>\n";

echo "<tr>\n";
echo "    <td><b>Folder/File</b></td>\n";
echo "    <td colspan='3'><b>Information</b></td></tr>\n";
echo "</tr>\n";

foreach ($phpMyDIR->resultFolder as $key => $val)
{
    echo "<tr>\n";
    echo "    <td colspan='3'>&nbsp;</td>\n";
    echo "</tr>\n";

    echo "<tr>\n";
    echo "    <td colspan='3'><b>".$val."</b></td>\n";
    echo "</tr>\n";

    foreach ($phpMyDIR->resultMixed[$val] as $skey => $sval)
    {
        echo "<tr>\n";
        echo "   <td><li>".$skey."</li></td>\n";
        echo "   <td>".$sval["time"]."&nbsp;</td>\n";
        echo "   <td>".$sval["size"]."</td>\n";
        echo "</tr>\n";
    }
}

echo "</table>\n";

echo "<hr>";

echo "<pre>\n";
print_r($phpMyDIR);
echo "</pre>\n";

***************************************************************************************************
*/


class phpMyDIR
{

    /**
     *  @access   public
     *  @param    string
     */
    var $baseRoot           = './';

    /**
     *  @access   public
     *  @param    string
     */
    var $globalDateFormat   = '%d. %B %Y | %H:%M';
    /**
     *  @access   public
     *  @param    array
     */
    var $globalDateDays     = array('So', 'Mo', 'Di', 'Mi', 'Do', 'Fr', 'Sa');
    /**
     *  @access   public
     *  @param    array
     */
    var $globalDateMonths   = array('Jan', 'Feb', 'Mr', 'Apr', 'Mai', 'Jun', 'Jul', 'Aug', 'Sept', 'Okt', 'Nov', 'Dez');

    /**
     *  @access   public
     *  @param    integer
     */
    var $globalSizeRound    = 2;
    /**
     *  @access   public
     *  @param    array
     */
    var $globalSizeUnits    = array('bytes', 'Kb', 'Mb', 'Gb', 'Tb', 'Pb', 'Eb');

    /**
     *  @access   public
     *  @param    string
     */
    var $globalSepThousands = '.';
    /**
     *  @access   public
     *  @param    string
     */
    var $globalSepDecimals  = ',';

    /**
     *  @access   public
     *  @param    string
     */
    var $fileMask           = '*';
    /**
     *  @access   public
     *  @param    bool
     */
    var $fileShowTime       = 1;
    /**
     *  @access   public
     *  @param    bool
     */
    var $fileShowSize       = 1;
    /**
     *  @access   public
     *  @param    bool
     */
    var $fileConvertTime    = 1;
    /**
     *  @access   public
     *  @param    bool
     */
    var $fileConvertSize    = 1;

    /**
     *  @access   public
     *  @param    string
     */
    var $folderMask         = '*';
    /**
     *  @access   public
     *  @param    bool
     */
    var $folderOnly         = 0;
    /**
     *  @access   public
     *  @param    bool
     */
    var $folderShowTime     = 1;
    /**
     *  @access   public
     *  @param    bool
     */
    var $folderConvertTime  = 1;

    /**
     *  @access   public
     *  @param    bool
     */
    var $spiderRecursive    = 0;
    /**
     *  @access   public
     *  @param    integer
     */
    var $spiderLevel        = 1;

    /**
     *  @access   public
     *  @param    array
     */
    var $resultMixed        = array();
    /**
     *  @access   public
     *  @param    array
     */
    var $resultFiles        = array();
    /**
     *  @access   public
     *  @param    array
     */
    var $resultFolder       = array();

    /**
     *  @access   private
     *  @param    mixed
     */
    var $_maskArray         = false;





    /**
     *  getResult()
     *
     *  start the search and return true or false based on search success
     *
     *  @access   public
     *  @return   bool
     *
     **/

    function getResult()
    {
        if (!preg_match("/\$/", $this->baseRoot))
        {
            $this->baseRoot = $this->baseRoot."/";
        }

        $this->_search($this->baseRoot);

        ksort ($this->resultMixed);
        sort ($this->resultFiles);
        sort ($this->resultFolder);

        return true;
    }

    /**
     *  fileMatch()
     *
     *  compare the given file with the file-mask
     *
     *  @access   public
     *  @param    string
     *  @return   bool
     *
     **/

    function fileMatch($file)
    {
        if ($this->_maskArray == 0)
        {
    	    $mask = $this->fileMask;
            $mask = str_replace(".", "\.", $mask);
            $mask = str_replace("*", "(.*)", $mask);
            $mask_array = explode(",",$mask);
            $this->_maskArray = array_map("trim", $mask_array);
        }

        foreach ($this->_maskArray as $valid)
        {
            if( preg_match("/$valid/i", $file) )
            {
                return true;
            }
        }
        return false;
    }

    /**
     *  getResult()
     *
     *  read the contents of the given root
     *
     * @access   private
     * @param    string
     * @param    integer
     *
     **/

    function _search($dir, $pos = 0)
    {
        $handle = @opendir($dir);
        while ($file = @readdir ($handle))
        {
            if (preg_match("/\.{1,2}/",$file))
            {
                continue;
            }
            if (is_dir($dir.$file))
            {
                $this->_folder($dir,$file,$pos);
            }
            if (is_file($dir.$file))
            {
                $this->_files($dir,$file,$pos);
            }
        }
        @closedir($handle);
    }

    /**
     *
     *  _folder($dir,$file,$pos)
     *
     * prepare a folder
     *
     * @access   private
     * @param    string
     * @param    string
     * @param    integer
     *
     **/

    function _folder($dir,$file,$pos)
    {
        $sdir = "/".str_replace($this->baseRoot, "", $dir.$file)."/";
        $this->resultFolder[] = $sdir;

        $tmp = array();
//        $tmp["_level"] = $pos;
//        $tmp["_name"]  = $sdir;
//        $tmp["_type"]  = "folder";

        if ($this->folderShowTime == 1)
        {
//            $tmp["_time"] = filemtime($dir.$file);
        }

        $this->resultMixed[$sdir] = $tmp;

        if ($this->spiderRecursive == 1 && ($pos < $this->spiderLevel || $this->spiderLevel == 0))
        {
            $this->_search($dir.$file."/", $pos + 1);
        }

    }

    /**
     *
     *  _files($dir,$file,$pos)
     *
     * prepare a file
     *
     * @access   private
     * @param    string
     * @param    string
     * @param    integer
     *
     **/

    function _files($dir,$file,$pos)
    {
        $sdir = "/".str_replace($this->baseRoot, "", $dir.$file)."/";
        if ( $this->fileMatch($file) == 1 && $this->folderOnly == 0 )
        {
            $this->resultFiles[] = $sdir.$file;

            $tmp = array();
            $tmp["level"] = $pos;
            $tmp["name"]  = $file;

            if ($this->fileShowTime == 1)
            {
                $tmp["time"] = filemtime($dir.$file);
                if ($this->fileConvertTime == 1)
                {
                    $tmp["time"] = $this->humanReadableTime($tmp["time"]);
                }
            }

            if ($this->fileShowSize == 1)
            {
                $tmp["size"] = filesize($dir.$file);
                if ($this->fileConvertSize == 1)
                {
                    $tmp["size"] = $this->humanReadableSize($tmp["size"]);
                }
            }

            $sdir = "/".str_replace($this->baseRoot, "", $dir);

            $this->resultMixed[$sdir][$file] = $tmp;
        }
    }

    /**
     *
     *  humanReadable($size=0)
     *
     *  convert bytes to kb, mb, gb
     *
     *  @access   public
     *  @param    integer     the size
     *  @return   string
     *
     **/

    function humanReadableSize($size = 0)
    {
        $faktor = $tmpfaktor = 1024;

        for ($i=0; $i < count($this->globalSizeUnits); $i++)
        {
            if ( ($size/$tmpfaktor) < 1 )
            {
                return round($size/($tmpfaktor/$faktor), $this->globalSizeRound)." ".$this->globalSizeUnits[$i];
            }
            $tmpfaktor = $faktor*$tmpfaktor;
        }
    }

    /**
     *
     *  @access   public
     *  @param    integer   the current timestamp
     *  @return   string    the formatted date
     *
     */

    function humanReadableTime($timestamp = -1)
    {
        if ($timestamp == -1)
        {
            $timestamp = time();
        }

        $date = str_replace('%[aA]', $this->globalDateDays[(int)strftime('%w', $timestamp)], $this->globalDateFormat);
        $date = str_replace('%[bB]', $this->globalDateMonths[(int)strftime('%m', $timestamp)-1], $date);

        return strftime($date, $timestamp);
    }

}

?>