<?php
//$zza = microtime();
// Aufruflink
// view-source:www.der-vermieter.info/cms/editmywmx/immosxml.php?sp=deutsch&zf=1&zp=1&ai=130001
/**
* immosxml.php exportiert Immobiliendaten aus der Aiyoota-DB
* in Datenaustauschdateien im XML-Format.

* Zielformate sind:
*  - OpenImmo
*  - ImmobilienScout24 (noch nicht unterstuetzt)

* Eingaben:
*  - Sprache sp (deutsch, ...) String kleiner 20 Zeichen
*  - Zielformat zf (1|2) (OpenImmo-Format|ImmobilenScout24-Format)
*  - Zielportal zp (1|2) (1=ImmoNet|2=Scout24)
*  - aiyootaID  ai ein int-Wert, kleiner als 10 Stellen
**/

// Validierung Uebergabeparameter
if (!(isset($_GET['sp']) && isset($_GET['zf']) && isset($_GET['zp']) && isset($_GET['ai']))) {
	die(); //"parameterfehler"
}

$sl = 20; // Eine gueltige Sprache ist weniger als 20 Zeichen lang
// Ist sp kuerzer als 20 Zeichen UND sind Slashes bzw. Tags enthalten?
if (strlen($_GET['sp']) < $sl && ($_GET['sp'] == stripslashes(strip_tags($_GET['sp'])))) {
	$sprache = $_GET['sp'];
} else {
	die(); //"sp flasch"
}

$gueltig = array(1, 2); // siehe Kopfkommentar
if (in_array($_GET['zf'], $gueltig)) {
	$zielformat = $_GET['zf'];
} else {
	die(); //"zf falsch"
}

$gueltig = array(1, 2); // siehe Kopfkommentar
if (in_array($_GET['zp'], $gueltig)) {
	$zielportal = $_GET['zp'];
} else {
	die(); //"zp falsch"
}

$sl = 10; // Eine gueltige aiyootaID ist weniger als 10 Stellen lang
if ($_GET['ai'] == (int) $_GET['ai'] && strlen($_GET['ai']) < $sl ) {
	$aiyootaID = $_GET['ai'];
} else {
	die(); //"ai flasch"
}
// ENDE: Validierung Uebergabeparaeter


require_once("../config/include/utils.runtime6.php");
require_once("../config/include/mysql.runtime6.php");
include("../../aidb.inc");


// ---- BEGINN FUNCTIONS ----

function get_xmlseitenkopf_OI ($arr) {
	$k = '<?xml version="1.0" encoding="'.$arr['encoding'].'" ?'.">\n";
	$k.= "<openimmo>\n";
	$k.= '<uebertragung art="ONLINE" umfang="VOLL" version="1.1" sendersoftware="'.$arr['sendsoftware'].'" tech_email="'.$arr['tech_email'].'" />';
	$k.= "\n<anbieter>";
	$k.= "\n\t<anbieternr>".$arr['anbieternr'].'</anbieternr>';
	$k.= "\n\t<firma>".$arr['firma'].'</firma>';
	$k.= "\n\t<openimmo_anid>".$arr['openimmo_anid'].'</openimmo_anid>';
	return $k;
}

function get_objektkategorie_OI ($arr) {
	$o = "\n\t<immobilie>\n";
	$o.= "<objektkategorie>\n";
	//$arr['nutzungsart'] = 1;
	switch ($arr['nutzungsart']) {
		case 1 : $o.= '<nutzungsart WOHNEN="1" />'."\n";
			break;
		case 2 : $o.= '<nutzungsart GEWERBE="1" />'."\n";
			break;
		case 3 : $o.= '<nutzungsart ANLAGE="1" />'."\n";
			break;
		case 4 : $o.= '<nutzungsart WAZ="1" />'."\n";
			break;
		default : $o.= "k.A. nutzungsart\n"; //die();
			break;
	}

	//$arr['vermarktungsart'] = 1;
	switch ($arr['vermarktungsart']) {
		case 1 : $o.= '<vermarktungsart KAUF="1" />'."\n";
			break;
		case 2 : $o.= '<vermarktungsart MIETE_PACHT="1" />'."\n";
			break;
		case 3 : $o.= '<vermarktungsart PACHT="1" />'."\n";
			break;
		case 4 : $o.= '<vermarktungsart ERBPACHT="1" />'."\n";
			break;
		case 5 : $o.= '<vermarktungsart LEASING="1" />'."\n";
			break;
		default : $o.= "k.A. vermarktungsart\n"; //die();
			break;
	}

	$o.= "<objektart>\n";

	//$arr['objektart'] = 'C9';
	switch ($arr['objektart']) {
		case '10' : $o.= '<zimmer zimmertyp="1" />'."\n";
			break;
		case '21' : $o.= '<wohnung wohnungtyp="DACHGESCHOSS" />'."\n";
			break;
		case '22' : $o.= '<wohnung wohnungtyp="MAISONETTE" />'."\n";
			break;
		case '23' : $o.= '<wohnung wohnungtyp="LOFT-STUDIO-ATELIER" />'."\n";
			break;
		case '24' : $o.= '<wohnung wohnungtyp="PENTHAUS" />'."\n";
			break;
		case '25' : $o.= '<wohnung wohnungtyp="TERRASSEN" />'."\n";
			break;
		case '26' : $o.= '<wohnung wohnungtyp="ETAGE" />'."\n";
			break;
		case '27' : $o.= '<wohnung wohnungtyp="ERDGESCHOSS" />'."\n";
			break;
		case '28' : $o.= '<wohnung wohnungtyp="SOUTERRAIN" />'."\n";
			break;
		case '31' : $o.= '<haus haustyp="REIHENHAUS" />'."\n";
			break;
		case '32' : $o.= '<haus haustyp="REIHENEND" />'."\n";
			break;
		case '33' : $o.= '<haus haustyp="REIHENMITTEL" />'."\n";
			break;
		case '34' : $o.= '<haus haustyp="REIHENECK" />'."\n";
			break;
		case '35' : $o.= '<haus haustyp="DOPPELHAUSHAELFTE" />'."\n";
			break;
		case '36' : $o.= '<haus haustyp="EINFAMILIENHAUS" />'."\n";
			break;
		case '37' : $o.= '<haus haustyp="STADTHAUS" />'."\n";
			break;
		case '38' : $o.= '<haus haustyp="VILLA" />'."\n";
			break;
		case '39' : $o.= '<haus haustyp="RESTHOF" />'."\n";
			break;
		case '310' : $o.= '<haus haustyp="BAUERNHAUS" />'."\n";
			break;
		case '311' : $o.= '<haus haustyp="LANDHAUS" />'."\n";
			break;
		case '312' : $o.= '<haus haustyp="SCHLOSS" />'."\n";
			break;
		case '313' : $o.= '<haus haustyp="ZWEIFAMILIENHAUS" />'."\n";
			break;
		case '314' : $o.= '<haus haustyp="MEHRFAMILIENHAUS" />'."\n";
			break;
		case '315' : $o.= '<haus haustyp="FERIENHAUS" />'."\n";
			break;
		case '316' : $o.= '<haus haustyp="BERGHUETTE" />'."\n";
			break;
		case '317' : $o.= '<haus haustyp="CHALET" />'."\n";
			break;
		case '318' : $o.= '<haus haustyp="STRANDHAUS" />'."\n";
			break;
		case '319' : $o.= '<haus haustyp="LAUBE-DATSCHE-GARTENHAUS" />'."\n";
			break;
		case '41' : $o.= '<grundstueck grundst_typ="WOHNEN" />'."\n";
			break;
		case '42' : $o.= '<grundstueck grundst_typ="GEWERBE" />'."\n";
			break;
		case '43' : $o.= '<grundstueck grundst_typ="INDUSTRIE" />'."\n";
			break;
		case '44' : $o.= '<grundstueck grundst_typ="LAND_FORSTWIRTSCHAFT" />'."\n";
			break;
		case '45' : $o.= '<grundstueck grundst_typ="FREIZEIT" />'."\n";
			break;
		case '46' : $o.= '<grundstueck grundst_typ="GEMISCHT" />'."\n";
			break;
		case '47' : $o.= '<grundstueck grundst_typ="SONDERNUTZUNG" />'."\n";
			break;
		case '51' : $o.= '<buero_praxen buero_typ="BUEROFLAECHE" />'."\n";
			break;
		case '52' : $o.= '<buero_praxen buero_typ="BUEROHAUS" />'."\n";
			break;
		case '53' : $o.= '<buero_praxen buero_typ="PRAXIS" />'."\n";
			break;
		case '54' : $o.= '<buero_praxen buero_typ="AUSSTELLUNGSFLAECHE" />'."\n";
			break;
		case '61' :  $o.= '<einzelhandel handel_typ="LADENLOKAL" />'."\n";
			break;
		case '62' :  $o.= '<einzelhandel handel_typ="EINZELHANDELSLADEN" />'."\n";
			break;
		case '63' :  $o.= '<einzelhandel handel_typ="VERBRAUCHERMARKT" />'."\n";
			break;
		case '64' :  $o.= '<einzelhandel handel_typ="EINKAUFSZENTRUM" />'."\n";
			break;
		case '71' : $o.= '<gastgewerbe gastgew_typ="GASTRONOMIE" />'."\n";
			break;
		case '72' : $o.= '<gastgewerbe gastgew_typ="GASTRONOMIE_UND_WOHNUNG" />'."\n";
			break;
		case '73' : $o.= '<gastgewerbe gastgew_typ="PENSIONEN" />'."\n";
			break;
		case '74' : $o.= '<gastgewerbe gastgew_typ="HOTELS" />'."\n";
			break;
		case '75' : $o.= '<gastgewerbe gastgew_typ="WEITERE_BEHERBUNGSBETRIEBE" />'."\n";
			break;
		case '81' : $o.= '<hallen_lager_prog hallen_typ="HALLE" />'."\n";
			break;
		case '82' : $o.= '<hallen_lager_prog hallen_typ="LAGER" />'."\n";
			break;
		case '83' : $o.= '<hallen_lager_prog hallen_typ="PRODUKTION" />'."\n";
			break;
		case '84' : $o.= '<hallen_lager_prog hallen_typ="WERKSTATT" />'."\n";
			break;
		case '91' : $o.= '<land_und_forstwirtschaft land_typ="LANDWIRTSCHAFTLICHE_BETRIEBE" />'."\n";
			break;
		case '92' : $o.= '<land_und_forstwirtschaft land_typ="BAUERNHOF" />'."\n";
			break;
		case '93' : $o.= '<land_und_forstwirtschaft land_typ="AUSSIEDLERHOF" />'."\n";
			break;
		case '94' : $o.= '<land_und_forstwirtschaft land_typ="GARTENBAU" />'."\n";
			break;
		case '95' : $o.= '<land_und_forstwirtschaft land_typ="ACKERBAU" />'."\n";
			break;
		case '96' : $o.= '<land_und_forstwirtschaft land_typ="WEINBAU" />'."\n";
			break;
		case '97' : $o.= '<land_und_forstwirtschaft land_typ="VIEHWIRTSCHAFT" />'."\n";
			break;
		case '98' : $o.= '<land_und_forstwirtschaft land_typ="JAGD_UND_FORSTWIRTSCAHFT" />'."\n";
			break;
		case '99' : $o.= '<land_und_forstwirtschaft land_typ="TEICH_UND_FISCHEREIWITSCHAFT" />'."\n";
			break;
		case '910' : $o.= '<land_und_forstwirtschaft land_typ="SCHEUNEN" />'."\n";
			break;
		case '911' : $o.= '<land_und_forstwirtschaft land_typ="REITERHOEFE" />'."\n";
			break;
		case '912' : $o.= '<land_und_forstwirtschaft land_typ="SONSTIGE _LANDWIRTSCHAFTIMMOBILIEN" />'."\n";
			break;
		case 'A1' : $o.= '<sonstige sonstige_typ="PARKHAUS" />'."\n";
			break;
		case 'A2' : $o.= '<sonstige sonstige_typ="TANKSTELLE" />'."\n";
			break;
		case 'A3' : $o.= '<sonstige sonstige_typ="GARAGEN" />'."\n";
			break;
		case 'A4' : $o.= '<sonstige sonstige_typ="PARKFLAECHE" />'."\n";
			break;
		case 'A5' : $o.= '<sonstige sonstige_typ="SONSTIGE" />'."\n";
			break;
		case 'B1' : $o.= '<freizeitimmobilie_gewerblich freizeit_typ="SPORTANLAGEN" />'."\n";
			break;
		case 'B2' : $o.= '<freizeitimmobilie_gewerblich freizeit_typ="VERGNUEGUNGSPARKS_UND_CENTER" />'."\n";
			break;
		case 'C1' : $o.= '<zinshaus_renditeobjekt zins_typ="MEHRFAMILIENHAUS" />'."\n";
			break;
		case 'C2' : $o.= '<zinshaus_renditeobjekt zins_typ="WOHN_UND_GESCHAEFTSHAUS" />'."\n";
			break;
		case 'C3' : $o.= '<zinshaus_renditeobjekt zins_typ="GESCHAEFTSHAUS" />'."\n";
			break;
		case 'C4' : $o.= '<zinshaus_renditeobjekt zins_typ="BUEROGEBAEUDE" />'."\n";
			break;
		case 'C5' : $o.= '<zinshaus_renditeobjekt zins_typ="SB_MAERKTE" />'."\n";
			break;
		case 'C6' : $o.= '<zinshaus_renditeobjekt zins_typ="EINKAUFSCENTREN" />'."\n";
			break;
		case 'C7' : $o.= '<zinshaus_renditeobjekt zins_typ="WOHNANLAGEN" />'."\n";
			break;
		case 'C8' : $o.= '<zinshaus_renditeobjekt zins_typ="VERBRAUCHERMAERKTE" />'."\n";
			break;
		case 'C9' : $o.= '<zinshaus_renditeobjekt zins_typ="INDUSTRIEANLAGEN" />'."\n";
			break;
		default : $o.= "k.A. objektart\n"; //die();
			break;
	}
	$o.= "</objektart>\n";
	$o.= "</objektkategorie>\n";
	return $o;
}

function get_geo_OI ($arr) {
	$g ="<geo>\n";
	strlen($arr['plz']) > 0 ? $g.="\t<plz>".$arr['plz']."</plz>\n" : $g.="";

	strlen($arr['ort']) > 0 ? $g.="\t<ort>".$arr['ort']."</ort>\n" : $g.="";

	strlen($arr['str']) > 0 ? $g.="\t<strasse>".$arr['str']."</strasse>\n" : $g.="";

	strlen($arr['hnr']) > 0 ? $g.="\t<hausnummer>".$arr['hnr']."</hausnummer>\n" : $g.="";

	switch($arr['buland']) {
		case 1 : $t = "Baden-Wrttemberg"; break;
		case 2 : $t = "Bayern"; break;
		case 3 : $t = "Berlin"; break;
		case 4 : $t = "Brandenburg"; break;
		case 5 : $t = "Bremen"; break;
		case 6 : $t = "Hamburg"; break;
		case 7 : $t = "Hessen"; break;
		case 8 : $t = "Mecklenburg- Vorpommern"; break;
		case 9 : $t = "Niedersachsen"; break;
		case 10 : $t = "Nordrhein-Westfalen"; break;
		case 11 : $t = "Rheinland-Pfalz"; break;
		case 12 : $t = "Saarland"; break;
		case 13 : $t = "Sachsen"; break;
		case 14 : $t = "Sachsen-Anhalt"; break;
		case 15 : $t = "Schleswig-Holstein"; break;
		case 16 : $t = "Thringen"; break;
		case 17 : $t = "Burgenland"; break;
		case 18 : $t = "K&auml;rnten"; break;
		case 19 : $t = "Nieder&ouml;sterreich"; break;
		case 20 : $t = "Ober&ouml;sterreich"; break;
		case 21 : $t = "Salzburg"; break;
		case 22 : $t = "Steiermark"; break;
		case 23 : $t = "Tirol"; break;
		case 24 : $t = "Vorarlberg"; break;
		case 25 : $t = "Wien"; break;
		case 26 : $t = "Aargau"; break;
		case 27 : $t = "Appenzell Ausserrhoden"; break;
		case 28 : $t = "Appenzell Innerrhoden"; break;
		case 29 : $t = "Basel-Land"; break;
		case 30 : $t = "Basel-Stadt"; break;
		case 31 : $t = "Bern"; break;
		case 32 : $t = "Freiburg"; break;
		case 33 : $t = "Genf"; break;
		case 34 : $t = "Glarus"; break;
		case 35 : $t = "Graub&uuml;nden"; break;
		case 36 : $t = "Jura"; break;
		case 37 : $t = "Luzern"; break;
		case 38 : $t = "Neuenburg"; break;
		case 39 : $t = "Nidwalden"; break;
		case 40 : $t = "Obwalden"; break;
		case 41 : $t = "Schaffhausen"; break;
		case 42 : $t = "Schwyz"; break;
		case 43 : $t = "Solothurn"; break;
		case 44 : $t = "St. Gallen"; break;
		case 45 : $t = "Tessin"; break;
		case 46 : $t = "Thurgau"; break;
		case 47 : $t = "Uri"; break;
		case 48 : $t = "Waadt"; break;
		case 49 : $t = "Wallis"; break;
		case 50 : $t = "Zug"; break;
		case 51 : $t = "Zrich"; break;
		default : $t = "";
	}
	strlen($t) > 0 ?
	$g.="\t<bundesland>".$t."</bundesland>\n" : $g.="";

	$t = $arr['land'];
	switch ($t) {
		case 1 : $t = "DEU"; break;
		case 2 : $t = "AUT"; break;
		case 3 : $t = "CHE"; break;
		default : $t = "";
	}
	strlen($t) > 0 ? $g.="\t<land>".$t."</land>\n" : $g.="";

	strlen($arr['etage']) > 0 ? $g.="\t<etage>".$arr['etage']."</etage>\n" : $g.="";

	strlen($arr['regionaler_zusatz']) > 0 ? $g.="\t<regionaler_zusatz>".$arr['regionaler_zusatz']."</regionaler_zusatz> \n" : $g.="";
	$g.="</geo>\n";
	return $g;
}

function get_kontaktperson_OI($arr) {
	$k ="<kontaktperson>\n";
	strlen($arr['email_direkt']) > 0 ? $k.="\t<email_direkt>".$arr['email_direkt']."</email_direkt>\n" : $k.="";

	strlen($arr['tel_zentrale']) > 0 ? $k.="\t<tel_zentrale>".$arr['tel_zentrale']."</tel_zentrale>\n" : $k.="";

	strlen($arr['tel_fax']) > 0 ? $k.="\t<tel_fax>".$arr['tel_fax']."</tel_fax>\n" : $k.="";

	strlen($arr['tel_handy']) > 0 ? $k.="\t<tel_handy>".$arr['tel_handy']."</tel_handy>\n" : $k.="";

	strlen($arr['name']) > 0 ? $k.="\t<name>".$arr['name']."</name>\n" : $k.="";

	strlen($arr['vorname']) > 0 ? $k.="\t<vorname>".$arr['vorname']."</vorname>\n" : $k.="";

	strlen($arr['titel']) > 0 ? $k.="\t<titel>".$arr['titel']."</titel>\n" : $k.="";

	strlen($arr['anrede']) > 0 ? $k.="\t<anrede>".$arr['anrede']."</anrede>\n" : $k.="";

	strlen($arr['firma']) > 0 ? $k.="\t<firma>".$arr['firma']."</firma>\n" : $k.="";

	strlen($arr['zusatzfeld']) > 0 ? $k.="\t<zusatzfeld>".$arr['zusatzfeld']."</zusatzfeld>\n" : $k.="";

	strlen($arr['strasse']) > 0 ? $k.="\t<strasse>".$arr['strasse']."</strasse>\n" : $k.="";

	strlen($arr['hausnummer']) > 0 ? $k.="\t<hausnummer>".$arr['hausnummer']."</hausnummer>\n" : $k.="";

	strlen($arr['plz']) > 0 ? $k.="\t<plz>".$arr['plz']."</plz>\n" : $k.="";

	strlen($arr['ort']) > 0 ? $k.="\t<ort>".$arr['ort']."</ort>\n" : $k.="";

	strlen($arr['land']) > 0 ? $k.="\t<land>".$arr['land']."</land>\n" : $k.="";

	strlen($arr['url']) > 0 ? $k.="\t<url>".$arr['url']."</url>\n" : $k.="";
	$k.="</kontaktperson>\n";
	return $k;
}

function get_preise_OI($arr) {
	$p ="<preise>\n";
	strlen($arr['kaufpreis']) > 0 ? $p.="\t<kaufpreis>".$arr['kaufpreis']."</kaufpreis>\n" : $p.="";

	strlen($arr['kaltmiete']) > 0 ? $p.="\t<kaltmiete>".$arr['kaltmiete']."</kaltmiete>\n" : $p.="";

	strlen($arr['nebenkosten']) > 0 ? $p.="\t<nebenkosten>".$arr['nebenkosten']."</nebenkosten>\n" : $p.="";

	strlen($arr['hausgeld']) > 0 ? $p.="\t<hausgeld>".$arr['hausgeld']."</hausgeld>\n" : $p.="";

	strlen($arr['mieteinnahmen_ist']) > 0 ? $p.="\t<mieteinnahmen_ist>".$arr['mieteinnahmen_ist']."</mieteinnahmen_ist>\n" : $p.="";

	strlen($arr['waehrung']) > 0 ? $p.="\t<waehrung>".$arr['waehrung']."</waehrung>\n" : $p.="";
	$p.="</preise>\n";
return $p;
}

function get_fleachen_OI($arr) {
	$f ="<flaechen>\n";
	strlen($arr['wohnflaeche']) > 0 ? $f.="\t<wohnflaeche>".$arr['wohnflaeche']."</wohnflaeche>\n" : $f.="";

	strlen($arr['nutzflaeche']) > 0 ? $f.="\t<nutzflaeche>".$arr['nutzflaeche']."</nutzflaeche>\n" : $f.="";

	strlen($arr['ladenflaeche']) > 0 ? $f.="\t<ladenflaeche>".$arr['ladenflaeche']."</ladenflaeche>\n" : $f.="";

	strlen($arr['lagerflaeche']) > 0 ? $f.="\t<lagerflaeche>".$arr['lagerflaeche']."</lagerflaeche>\n" : $f.="";

	strlen($arr['bueroflaeche']) > 0 ? $f.="\t<bueroflaeche>".$arr['bueroflaeche']."</bueroflaeche>\n" : $f.="";

	strlen($arr['grundstuecksflaeche']) > 0 ? $f.="\t<grundstuecksflaeche>".$arr['grundstuecksflaeche']."</grundstuecksflaeche>\n" : $f.="";

	strlen($arr['anzahl_zimmer']) > 0 ? $f.="\t<anzahl_zimmer>".$arr['anzahl_zimmer']."</anzahl_zimmer>\n" : $f.="";
	$f.="</flaechen>\n";
return $f;
}

function get_ausstattung_OI($arr) {
	$f ="<ausstattung>\n";
	strlen($arr['anzahl_balkon_terrassen']) > 0 ? $f.="\t<anzahl_balkon_terrassen>".$arr['anzahl_balkon_terrassen']."</anzahl_balkon_terrassen>\n" : $f.="";

	strlen($arr['ausricht_balkon_terrasse']) > 0 ? $f.="\t<ausricht_balkon_terrasse>".$arr['ausricht_balkon_terrasse']."</ausricht_balkon_terrasse>\n" : $f.="";

	strlen($arr['balkon_terrasse_flaeche']) > 0 ? $f.="\t<balkon_terrasse_flaeche>".$arr['balkon_terrasse_flaeche']."</balkon_terrasse_flaeche>\n" : $f.="";

	strlen($arr['stellplatzart']) > 0 ? $f.="\t<stellplatzart>".$arr['stellplatzart']."</stellplatzart>\n" : $f.="";

	strlen($arr['stellplatzmiete']) > 0 ? $f.="\t<stellplatzmiete>".$arr['stellplatzmiete']."</stellplatzmiete>\n" : $f.="";

	strlen($arr['stellplatzkauf']) > 0 ? $f.="\t<stellplatzkauf>".$arr['stellplatzkauf']."</stellplatzkauf>\n" : $f.="";

	strlen($arr['stellplatzanzahl']) > 0 ? $f.="\t<stellplatzanzahl>".$arr['stellplatzanzahl']."</stellplatzanzahl>\n" : $f.="";
	strlen($arr['gartenflaeche']) > 0 ? $f.="\t<gartenflaeche>".$arr['gartenflaeche']."</gartenflaeche>\n" : $f.="";
	strlen($arr['gartennutzung']) > 0 ? $f.="\t<gartennutzung>".$arr['gartennutzung']."</gartennutzung>\n" : $f.="";
	strlen($arr['kueche_ebk']) > 0 ? $f.="\t<kueche_ebk>".$arr['kueche_ebk']."</kueche_ebk>\n" : $f.="";
	strlen($arr['kueche_offen']) > 0 ? $f.="\t<kueche_offen>".$arr['kueche_offen']."</kueche_offen>\n" : $f.="";
	strlen($arr['kamin']) > 0 ? $f.="\t<kamin>".$arr['kamin']."</kamin>\n" : $f.="";
	$f.="</ausstattung>\n";
return $f;
}

function get_zustand_angaben_OI($arr) {
	$z ="<zustand_angaben>\n";
	if (preg_match('/^[\d]{4}$/', $z)) {
		$z.="\t<baujahr>".$arr['baujahr']."</baujahr>\n";
	} else {
		$z.="";
	}
	switch ($arr['zustand']) {
		case 1 : $t ="ERSTBEZUG"; break;
		case 2 : $t ="TEIL_VOLLRENOVIERUNGSBED"; break;
		case 3 : $t ="NEUWERTIG"; break;
		case 4 : $t ="TEIL_VOLLSANIERT"; break;
		case 5 : $t ="TEIL_VOLLRENOVIERT"; break;
		case 6 : $t ="BAUFAELLIG"; break;
		case 7 : $t ="NACH_VEREINBARUNG"; break;
		case 8 : $t ="MODERNISIERT"; break;
		case 9 : $t ="GEPFLEGT"; break;
		case 10 : $t ="ROHBAU"; break;
		case 11 : $t ="ENTKERNT"; break;
		case 12 : $t ="ABRISSOBJEKT"; break;
		case 13 : $t ="PROJEKTIERT"; break;
		default : $t =""; break;
	}
	strlen($t) > 0 ? $z.="\t".'<zustand zustand_art="'.$t.'" />'."\n" : $z.="";

	switch ($arr['alter']) {
		case 1 : $t ="ALTBAU"; break;
		case 2 : $t ="NEUBAU"; break;
		default : $t =""; break;
	}
	strlen($t) > 0 ? $z.="\t".'<alter alter_attr="'.$t.'" />'."\n" : $z.="";

	switch ($arr['bebaubar']) {
		case 1 : $t ="34_NACHBARSCHAFT"; break;
		case 2 : $t ="35_AUSSENGEBIET"; break;
		case 3 : $t ="B_PLAN"; break;
		case 4 : $t ="KEIN BAULAND"; break;
		case 5 : $t ="BAUERWARTUNGSLAND"; break;
		default : $t =""; break;
	}
	strlen($t) > 0 ? $z.="\t".'<bebaubar_nach bebaubar_attr="'.$t.'" />'."\n" : $z.="";

	switch ($arr['erschliessung']) {
		case 1 : $t ="UNERSCHLOSSEN"; break;
		case 2 : $t ="TEILERSCHLOSSEN"; break;
		case 3 : $t ="VOLLERSCHLOSSEN"; break;
		default : $t =""; break;
	}
	strlen($t) > 0 ? $z.="\t".'<erschliessung erschl_attr="'.$t.'" />'."\n" : $z.="";
	$z.="</zustand_angaben>\n";
return $z;
}

function get_freitexte_OI($arr) {
	$f ="<freitexte>\n";
 	strlen($arr['objekttitel']) > 0 ? $f.="\t<objekttitel>".$arr['objekttitel']."</objekttitel>\n" : $f.="";

 	strlen($arr['dreizeiler']) > 0 ? $f.="\t<dreizeiler>".$arr['dreizeiler']."</dreizeiler>\n" : $f.="";

 	strlen($arr['lage']) > 0 ? $f.="\t<lage>".$arr['lage']."</lage>\n" : $f.="";

 	strlen($arr['objektbeschreibung']) > 0 ? $f.="\t<objektbeschreibung>".$arr['objektbeschreibung']."</objektbeschreibung>\n" : $f.="";

 	strlen($arr['sonstige_angaben']) > 0 ? $f.="\t<sonstige_angaben>".$arr['sonstige_angaben']."</sonstige_angaben>\n" : $f.="";
 	$f.="</freitexte>\n";
	return $f;
}

function get_anhaenge_OI($arr) {
	$a ="<anhaenge>\n";

	if(strlen($arr['pfad1'])) {
		$a.="\t".'<anhang location="EXTERN" gruppe="TITELBILD">'."\n";
		$a.="\t\t<format>image/jpeg</format>\n";
		$a.="\t\t<daten>\n";
		$a.="\t\t\t<pfad>".$arr['pfad1']."</pfad>\n";
		$a.="\t\t</daten>\n";
		$a.="\t</anhang>\n";
	}

	for ($ia=2;$ia<=7;$ia++) {
		if((isset($arr['pfad'.$ia])) && (strlen($arr['pfad'.$ia]))) {
			$a.="\t".'<anhang location="EXTERN" gruppe="BILD">'."\n";
			$a.="\t\t<anhangtitel>Bild ".$ia."</anhangtitel>\n";
			$a.="\t\t<format>image/jpeg</format>\n";
			$a.="\t\t<daten>\n";
			$a.="\t\t\t<pfad>".$arr['pfad'.$ia]."</pfad>\n";
			$a.="\t\t</daten>\n";
			$a.="\t</anhang>\n";
		}
	}

 	$a.="</anhaenge>\n";
return $a;
}

function get_verwaltung_objekt_OI($arr) {
	$v ="<verwaltung_objekt>\n";
	$muster ="/^[\d]{4}-[\d]{2}-[\d]{2}$/";
	//$arr['verfuegbar_ab'] = "1970-01-01";
	preg_match($muster, $arr['verfuegbar_ab']) ? $v.= "\t<verfuegbar_ab>".$arr['verfuegbar_ab']."</verfuegbar_ab>\n" : $v.="";
 	strlen($arr['vermietet']) > 0 ? $v.="\t<vermietet>".$arr['vermietet']."</vermietet>\n" : $v.="";
 	$v.="</verwaltung_objekt>\n";
return $v;

}

function get_verwaltung_techn_OI($arr) {
	$v ="<verwaltung_techn>\n";
 	strlen($arr['objektnr_intern']) > 0 ? $v.="\t<objektnr_intern>".$arr['objektnr_intern']."</objektnr_intern>\n" : $v.="";
 	strlen($arr['objektnr_extern']) > 0 ? $v.="\t<objektnr_extern>".$arr['objektnr_extern']."</objektnr_extern>\n" : $v.="";
 	$v.="\t<aktion />\n";
 	strlen($arr['openimmo_obid']) > 0 ? $v.="\t<openimmo_obid>".$arr['openimmo_obid']."</openimmo_obid>\n" : $v.="";
 	strlen($arr['stand_vom']) > 0 ? $v.="\t<stand_vom>".$arr['stand_vom']."</stand_vom>\n" : $v.="";
 	$v.="</verwaltung_techn>\n\t</immobilie>\n";
return $v;
}

function get_xmlseitenfuss_OI () {
	return "\t</anbieter>\n</openimmo>";
}

function Encoder($text) {
	$text=preg_replace("/\x84|\x93|\'\'|&quot;/","\"", $text); 	// hier Kriterien durch ["] ersetzen lassen
	$text=preg_replace("/\s|&quot;|&nbsp;/"," ", $text);		// hier Kriterien (\s schliesst \n u.s.w. ein) durch [LEERZ.] ersetzen lassen
	$text=preg_replace("/&amp;|& |&/","und ", $text);					// hier Kriterien durch [und]
	$text=str_replace("<br>","<br />",$text);
return $text;
}

function explode_anrede($str) {
	$arr = explode(" ", $str);
	switch (count ($arr) ) {
		case 1 :
			$arr_ret[0] = $arr[0];
			$arr_ret[1] = "";
			break;
		case 2 :
			$arr_ret = $arr;
			break;
		default :
			$arr_ret = array("k.A.", "k.A.");
			break;
	}
	return $arr_ret;
}

function explode_ansprechpartner($str) {
	$arr = explode(" ", $str);
	switch (count ($arr) ) {
		case 1 :
			$arr_ret[0] = $arr[0];
			$arr_ret[1] = "";
			break;
		case 2 :
			$arr_ret = $arr;
			break;
		default :
			$arr_ret = array("k.A.", "k.A.");
			break;
	}
	return $arr_ret;
}

function ftp_upload ($arr, $str) {
	$fh = tmpfile();
	if (!$fh) {return false;}
	if (($anz = fwrite($fh, $str)) === false) {
		fclose($fh);
		return false;
	} else {
		fseek($fh,0);
		// FTP
		$conn_id = ftp_connect($arr['FtpAdresse']);
		if(!$conn_id) {
			fclose($fh);
			die("Keine Verbindung zu FtpAdresse moeglich");
		}
		$login_result = ftp_login($conn_id, $arr['FtpLogin'], $arr['FtpPassw']);
		if(!$login_result) {
			ftp_close($conn_id);
			fclose($fh);
			die("Kein Login moeglich");
		}
		$bool = ftp_chdir($conn_id, $arr['FtpPfad']);
		if(!$bool) {
			ftp_close($conn_id);
			fclose($fh);
			die("Kein Verzeichniswechsel moeglich");
		}
		$bool = ftp_fput($conn_id, $arr['filename'], $fh, FTP_ASCII);
		if(!$bool) {
		ftp_close($conn_id);
		fclose($fh);
		die("Ffehler beim Kopieren");
		}
		ftp_close($conn_id);
		fclose($fh);
	}
	return true;
}

function get_vorhande_eigenschaften ($arr) {
/**
* Zu den Aiyoota-Immobilien koennten optionale Eigenschaften definiert sein.
*/
	$sql = "select klick1, klick2, klick3, klick4, klick5, ";
	$sql.= "klick6, klick7, klick8, klick9, klick10 ";
	$sql.= "from kontakt ";
	$sql.= "where ID ='".$arr['kontaktID']."' ";
	$Name = WrapMySQLDatabaseResults($arr['ai_database'], $sql, "block=1","Name");

	$Name->MoveFirst();
	$str="";
	for ($i=1; $i<11; ++$i) {
		if(strlen($Name->Value('klick'.$i)) && strlen($arr['wert'.$i])) {
			$str.="\n".$Name->Value('klick'.$i).": ".$arr['wert'.$i];
		}
	}
	if (strlen($str)) {$str = $str."\n";} else {$str = "";}
	return $str;
}

function get_xmlseitenkopf_IS24($arr) {
	$k = '<?xml version="1.0" encoding="'.$arr['encoding'].'" ?'.">\n";
	$k.= '<IS24ImmobilienTransfer
		xmlns="http://www.immobilienscout24.de/immobilientransfer"
		xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
		xsi:schemaLocation="http://www.immobilienscout24.de/immobilientransfer is24immotransfer.xsd"
		ErstellerSoftware="'.$arr['sendsoftware'].'"
		ErstellerSoftwareVersion="'.$arr['sendsoftware'].'"
		EmailBeiFehler="'.$arr['tech_email'].'">'."\n";
	$k.= "\t".'<Anbieter ScoutKundenID="'.$arr['anbieternr'].'">'."\n";
	return $k;
}

function get_Immotyp_IS24($arr) {
	/**	Aus Nutzungsart, Vermarktungsart u. Objektart den
	*	Immobilientyp von ImmoScout24 ermitteln
	*/
	$objekart = substr($arr['objektart'],0,1); // (1-C) hex aus z.B. A9
	switch ($objekart) {
		case 1 : //Zimmer;
		case 2 : //Wohnung;
			$o = "Wohnung";
			switch ($arr['vermarktungsart']) {
				case 1 : $v = "Kauf"; break;
				case 2 : $v = "Miete"; break;
				default : $v = ""; break;
			}
			$immotyp = $o.$v;
			break;
		case 3 : //Haus; break;
			$o = "Haus";
			switch ($arr['vermarktungsart']) {
				case 1 : $v = "Kauf"; break;
				case 2 : $v = "Miete"; break;
				default : $v = ""; break;
			}
			$immotyp = $o.$v;
			break;
		case 4 : //Grundstueck;
			$o = "Grundstueck";
			switch ($arr['nutzungsart']) {
				case 1 : $n = "Wohnen";
					switch ($arr['vermarktungsart']) {
						case 1 : $v = "Kauf"; break;
						case 2 : $v = "Miete"; break;
						default : $v = ""; break;
					}
					$n = $n.$v;
					break;
				case 2 : $n = "Gewerbe"; break;
				default : $n = ""; break;
			}
			$immotyp = $o.$n;
			break;
		case 5 : //Buero Praxen;
			$immotyp = "BueroPraxis"; break;
		case 6 : //Einzelhandel;
			$immotyp = "Einzelhandel"; break;
		case 7 : //Gastgewerbe;
			$immotyp = "Gastronomie"; break;
		case 8 : //Hallen Lager Produktion;
			$immotyp = "HalleProduktion"; break;
		case 9 : //Land- und Forstwirtschaft; break;
		case 'A' : //sonstige;
			if($arr['objektart']=="A3") {
				$o = "Garage";
				switch ($arr['vermarktungsart']) {
					case 1 : $v = "Kauf"; break;
					case 2 : $v = "Miete"; break;
					default : $v = ""; break;
				}
				$immotyp = $o.$v;
			} else {
				$immotyp = "SonstigeGewerbe";
			}
			break;
		case 'B' : //Freizeitimmobilie gewerblich; break;
		case 'C' : //Zinshaus Renditeobjekt; break;
		default :
			switch ($arr['nutzungsart']) {
				case 2 : // Gewerbe;
				case 3 : // Anlage;
					$immotyp = "SonstigeGewerbe";
					break;
				case 3 : // WAZ;
					$immotyp = "WAZ";
					break;
				default : $immotyp = "";
					break;
			}
			break;
	}
	return $immotyp;
}

function get_Objektadresse_IS24 ($arr) {
	$g ="\n\t<Adresse\n";
	strlen($arr['str']) > 0 ? $g.="\tStrasse=\"".$arr['str']."\"\n" : $g.="";

	strlen($arr['hnr']) > 0 ? $g.="\tHausnummer=\"".$arr['hnr']."\"\n" : $g.="";

	strlen($arr['ort']) > 0 ? $g.="\tOrt=\"".$arr['ort']."\"\n" : $g.="";

	strlen($arr['plz']) > 0 ? $g.="\tPostleitzahl=\"".$arr['plz']."\"\n" : $g.="";

	/*switch($arr['buland']) {
		case 1 : $t = "Baden-Wrttemberg"; break;
		case 2 : $t = "Bayern"; break;
		case 3 : $t = "Berlin"; break;
		case 4 : $t = "Brandenburg"; break;
		case 5 : $t = "Bremen"; break;
		case 6 : $t = "Hamburg"; break;
		case 7 : $t = "Hessen"; break;
		case 8 : $t = "Mecklenburg- Vorpommern"; break;
		case 9 : $t = "Niedersachsen"; break;
		case 10 : $t = "Nordrhein-Westfalen"; break;
		case 11 : $t = "Rheinland-Pfalz"; break;
		case 12 : $t = "Saarland"; break;
		case 13 : $t = "Sachsen"; break;
		case 14 : $t = "Sachsen-Anhalt"; break;
		case 15 : $t = "Schleswig-Holstein"; break;
		case 16 : $t = "Thringen"; break;
		case 17 : $t = "Burgenland"; break;
		case 18 : $t = "K&auml;rnten"; break;
		case 19 : $t = "Nieder&ouml;sterreich"; break;
		case 20 : $t = "Ober&ouml;sterreich"; break;
		case 21 : $t = "Salzburg"; break;
		case 22 : $t = "Steiermark"; break;
		case 23 : $t = "Tirol"; break;
		case 24 : $t = "Vorarlberg"; break;
		case 25 : $t = "Wien"; break;
		case 26 : $t = "Aargau"; break;
		case 27 : $t = "Appenzell Ausserrhoden"; break;
		case 28 : $t = "Appenzell Innerrhoden"; break;
		case 29 : $t = "Basel-Land"; break;
		case 30 : $t = "Basel-Stadt"; break;
		case 31 : $t = "Bern"; break;
		case 32 : $t = "Freiburg"; break;
		case 33 : $t = "Genf"; break;
		case 34 : $t = "Glarus"; break;
		case 35 : $t = "Graub&uuml;nden"; break;
		case 36 : $t = "Jura"; break;
		case 37 : $t = "Luzern"; break;
		case 38 : $t = "Neuenburg"; break;
		case 39 : $t = "Nidwalden"; break;
		case 40 : $t = "Obwalden"; break;
		case 41 : $t = "Schaffhausen"; break;
		case 42 : $t = "Schwyz"; break;
		case 43 : $t = "Solothurn"; break;
		case 44 : $t = "St. Gallen"; break;
		case 45 : $t = "Tessin"; break;
		case 46 : $t = "Thurgau"; break;
		case 47 : $t = "Uri"; break;
		case 48 : $t = "Waadt"; break;
		case 49 : $t = "Wallis"; break;
		case 50 : $t = "Zug"; break;
		case 51 : $t = "Zrich"; break;
		default : $t = "";
	}
	strlen($t) > 0 ?
	$g.="\t<bundesland>".$t."</bundesland>\n" : $g.="";
	*/

	$t = $arr['land'];
	switch ($t) {
		case 1 : $t = "DEU"; break;
		case 2 : $t = "AUT"; break;
		case 3 : $t = "CHE"; break;
		default : $t = "";
	}
	strlen($t) > 0 ? $g.="\tLaenderkennzeichen=\"".$t."\"\n" : $g.="";

	/*strlen($arr['etage']) > 0 ? $g.="\t<etage>".$arr['etage']."</etage>\n" : $g.="";

	strlen($arr['regionaler_zusatz']) > 0 ? $g.="\t<regionaler_zusatz>".$arr['regionaler_zusatz']."</regionaler_zusatz> \n" : $g.=""; */
	$g.="\t/>\n";
	return $g;
}

function get_Kontaktperson_IS24($arr) {
	$k ="\t<Kontaktperson\n";

	// strlen($arr['titel']) > 0 ? $k.="\t<titel>".$arr['titel']."</titel>\n" : $k.="";

	strlen($arr['anrede']) > 0 ? $k.="\tAnrede=\"".$arr['anrede']."\"\n" : $k.="";

	strlen($arr['vorname']) > 0 ? $k.="\tVorname=\"".$arr['vorname']."\"\n" : $k.="";

	strlen($arr['name']) > 0 ? $k.="\tNachname=\"".$arr['name']."\"\n" : $k.="";

	strlen($arr['strasse']) > 0 ? $k.="\tStrasse=\"".$arr['strasse']."\"\n" : $k.="";

	strlen($arr['hausnummer']) > 0 ? $k.="\tHausnummer=\"".$arr['hausnummer']."\"\n" : $k.="";

	strlen($arr['ort']) > 0 ? $k.="\tOrt=\"".$arr['ort']."\"\n" : $k.="";

	strlen($arr['plz']) > 0 ? $k.="\tPostleitzahl=\"".$arr['plz']."\"\n" : $k.="";

	strlen($arr['land']) > 0 ? $k.="\tLaenderkennzeichen=\"".$arr['land']."\"\n" : $k.="";

	strlen($arr['tel_zentrale']) > 0 ? $k.="\tTelefon=\"".$arr['tel_zentrale']."\"\n" : $k.="";

	strlen($arr['tel_handy']) > 0 ? $k.="\tMobiltelefon=\"".$arr['tel_handy']."\"\n" : $k.="";

	strlen($arr['tel_fax']) > 0 ? $k.="\tTelefax=\"".$arr['tel_fax']."\"\n" : $k.="";

	strlen($arr['url']) > 0 ? $k.="\tHomepage=\"".$arr['url']."\"\n" : $k.="";

	strlen($arr['email_direkt']) > 0 ? $k.="\tEMail=\"".$arr['email_direkt']."\"\n" : $k.="";

	/*
	strlen($arr['firma']) > 0 ? $k.="\t<firma>".$arr['firma']."</firma>\n" : $k.="";

	strlen($arr['zusatzfeld']) > 0 ? $k.="\t<zusatzfeld>".$arr['zusatzfeld']."</zusatzfeld>\n" : $k.="";
	*/
	$k.="\t/>\n";
	return $k;
}

function get_SonstigeAngaben_IS24() {
	return "get_SonstigeAngaben_IS24\n";

}

function get_MultimediaAnhang_IS24() {
	return "get_MultimediaAnhang_IS24\n";

}

function get_preise_IS24() {
	return "get_preise_IS24\n";

}

function get_xmlseitenfuss_IS24 () {
	return "\t</Anbieter>\n</IS24ImmobilienTransfer>";
}

// ---- END FUNCTIONS ----

//SQL-Abfrage fuer Kopf-/Anbieterdaten aus TB Grunddaten
$sql ="select firmenname, email ";

//$sql.="anbieternr1, FtpLogin1, FtpPassw1 "; // immonet
//$sql.="anbieternr2, FtpLogin2, FtpPassw2 "; // IS24
//$sql.="anbieternr3, FtpLogin3, FtpPassw3 ";
//$sql.="anbieternr4, FtpLogin4, FtpPassw4 ";
//$sql.="anbieternr5, FtpLogin5, FtpPassw5 ";

$sql.="from Grunddaten ";
$sql.="where sprache = '".$GLOBALS["sprache"]."' and ";
$sql.="aiyootaID='".$aiyootaID."' ";
// echo $sql;
$Anbieter=WrapMySQLDatabaseResults("$ai_database", $sql, "block=1","Anbieter");
$Anbieter->MoveFirst();

$arrPL1['sendsoftware'] = "AiyootaCMS"; //"MySoft"
$arrPL1['tech_email'] = Encoder($Anbieter->Value("email")); //"my@mail.tld"
$arrPL1['firma'] = Encoder($Anbieter->Value("firmenname")); //"Haus und Hof"
$arrPL1['openimmo_anid'] = "AATA20060117084020513TTzg15ptw2";
$arrPL1['encoding'] = "UTF-8";

switch ($zielportal) {
	case 1: // ImmoNet
		$arrPL1['anbieternr'] = "436354";
		$arrPL1['FtpAdresse'] = "ftp.immonet.de";
		$arrPL1['FtpLogin'] = "wdpx-wollweber";
		$arrPL1['FtpPassw'] = "hoo=w7We";
		$arrPL1['FtpPfad'] = "/"; // z.B. "/verz/uvers/" od. "/"
		$arrPL1['filename'] = "immonet_".$aiyootaID.".xml";
		$arrPL1['ausgabeart'] = 3; //1:Browser, 2:Download, 3:FTP-Upload
		break;
	case 2: // IS24
		$arrPL1['anbieternr'] = "1514561"; //ScoutKundenID
		$arrPL1['FtpAdresse'] = "ftp.immobilienscout24.de";
		$arrPL1['FtpLogin'] = "1514561";
		$arrPL1['FtpPassw'] = "100562";
		$arrPL1['FtpPfad'] = ""; // z.B. "/verz/uvers/"
		$arrPL1['filename'] = "is24_".$aiyootaID.".xml";
		$arrPL1['ausgabeart'] = 1; //1:Browser, 2:Download, 3:FTP-Upload
		break;
	/*
	case 3: // XYZ
		$arrPL1['anbieternr'] = "";
		$arrPL1['FtpAdresse'] = "";
		$arrPL1['FtpLogin'] = "";
		$arrPL1['FtpPassw'] = "";
		$arrPL1['FtpPfad'] = ""; // z.B. "/verz/uvers/"
		$arrPL1['filename'] = "xyz_".$aiyootaID.".xml";
		$arrPL1['ausgabeart'] = 1; //1:Browser, 2:Download, 3:FTP-Upload
		break;
	case 4: // XYZ
		$arrPL1['anbieternr'] = "";
		$arrPL1['FtpAdresse'] = "";
		$arrPL1['FtpLogin'] = "";
		$arrPL1['FtpPassw'] = "";
		$arrPL1['FtpPfad'] = ""; // z.B. "/verz/uvers/"
		$arrPL1['filename'] = "xyz_".$aiyootaID.".xml";
		$arrPL1['ausgabeart'] = 1; //1:Browser, 2:Download, 3:FTP-Upload
		break;
	case 5: // XYZ
		$arrPL1['anbieternr'] = "";
		$arrPL1['FtpAdresse'] = "";
		$arrPL1['FtpLogin'] = "";
		$arrPL1['FtpPassw'] = "";
		$arrPL1['FtpPfad'] = ""; // z.B. "/verz/uvers/"
		$arrPL1['filename'] = "xyz_".$aiyootaID.".xml";
		$arrPL1['ausgabeart'] = 1; //1:Browser, 2:Download, 3:FTP-Upload
		break;
	*/
	default:
			die("Portal wird nicht unterstuetzt");
		break;
}

// benoetigte Spalten aus den Tabellen adressen und branchen
$zp = &$zielportal;
$t ="ID, branche, firma, anrede, ansprechpartner, adresse, hausnummer, plz, ";
$t.="ort, land, tel, fax, email, internet, anfrage1, anfrage2, anfrage3, ";
$t.="bild1, bild2, bild3, bild4, bild5, bild6, bild7, bild8, bild9, bild10, bild11, bild12, bild13, bild14, bild15, bild16, bild17, bild18, bild19, bild20, ";
$t.="immo_km, immo_nk, immo_qm, immo_grundflaeche, immo_wohnflaeche, ";
$t.="immo_grundstueck, immo_kaufpreis, immo_hausgeld, immo_mieteinnahme, betriebskosten, ";
$t.="immo_nutzungsart, immo_vermarktungsart, immo_objektart, ";
$t.="immo_plz, immo_ort, immo_str, immo_hnr, immo_buland, immo_land, ";
$t.="immo_etage, immo_anzzimmer, immo_baujahr, immo_zustand, immo_alter, ";
$t.="immo_bebaubar, immo_erschliessung, immo_dreizeiler, immo_lage, ";
$t.="immo_verfuegbar_ab, immo_vermietet, ";
$t.="anzahl_balkon_terrassen, ausricht_balkon_terrasse, balkon_terrasse_flaeche, stellplatzart, stellplatzmiete, stellplatzkauf, stellplatzanzahl, gartenflaeche, gartennutzung, kueche_ebk, kueche_offen, kamin, ";
$t.="courtage, courtageart, ";
$t.="klick1, klick2, klick3, klick4, klick5, ";
$t.="klick6, klick7, klick8, klick9, klick10, ";
$t.="zielformat".$zp.", zielportalonoff".$zp." ";
$spalten_aus_adressen = $t;

$t = "bezeichnung, kontaktID "; //kontaktID zu Bezeichnungen von klick1-10 aufl.
//$t.= "nutzungsart, vermarktungsart, objektart ";
$spalten_aus_branchen = $t;

//SQL-Abfrage fuer Immobiliendaten
// Prinzip:
// Untermenge aus TB adressen LEFT JOIN mit Untermenge aus TB branchen
$sql ="SELECT * FROM ";
$sql.=	"(select ".$spalten_aus_adressen." ";
$sql.=	"from adressen ";
$sql.=	"where zielportalonoff".$zp."= 1 "; //z.B. zielportalonoff1=1  (1=ON)
$sql.=	"and aiyootaID='".$aiyootaID."' ) AS TMadressen ";
//$sql.=	"where aiyootaID='".$aiyootaID."' ) AS TMadressen ";
$sql.="LEFT JOIN ";
$sql.=	"(select ".$spalten_aus_branchen." ";
$sql.=	"from branchen ";
$sql.=	"where aiyootaID='".$aiyootaID."' ) AS TMbranchen ";
$sql.="ON TMadressen.branche = TMbranchen.bezeichnung ";

// 		Testabfrage
// 		$sql ="SELECT * FROM ";
// 		$sql.=	"(select branche, firma ";
// 		$sql.=	"from adressen ";
// 		$sql.=	") AS TMadressen ";
// 		$sql.="LEFT JOIN ";
// 		$sql.=	"(select bezeichnung, art ";
// 		$sql.=	"from branchen ";
// 		$sql.=	"where aiyootaID='".$aiyootaID."' ) AS TMbranchen ";
// 		$sql.="ON TMadressen.branche = TMbranchen.bezeichnung LIMIT 0,1 ";
//echo $sql; die();
$ImmoDS=WrapMySQLDatabaseResults("$ai_database", $sql, "block=1","ImmoDS");
//echo var_dump($ImmoDS);
//echo $ImmoDS->RecordCount();

$zf = $ImmoDS->Value('zielformat'.$zp);
switch ($zf) {
	case 1 : // OpenImmo-Format (nur Teilmenge)
		$xmlseite = get_xmlseitenkopf_OI($arrPL1);
		$ImmoDS->MoveFirst();
		//$zaehler = 0; $zaehler < 5 &&
		while (!$ImmoDS->EOF()) {
			//$zaehler ++;
			// objektkategorie
			$arrPL2['nutzungsart'] = $ImmoDS->Value('immo_nutzungsart'); // 1 = WOHNEN ...
			$arrPL2['vermarktungsart'] = $ImmoDS->Value('immo_vermarktungsart');	// 1 = KAUF ...
			$objektart = $ImmoDS->Value('immo_objektart');
			$arrPL2['objektart'] = $objektart;	// hexdez 318 STRANDHAUS
			$immo_ds = get_objektkategorie_OI($arrPL2);

			// geo (u.a. Adresse der Immobilie)
			$arrPL3['plz'] = strip_tags($ImmoDS->Value('immo_plz'));
			$arrPL3['ort'] = strip_tags($ImmoDS->Value('immo_ort'));
			$arrPL3['str'] = strip_tags($ImmoDS->Value('immo_str'));
			$arrPL3['hnr'] = strip_tags($ImmoDS->Value('immo_hnr'));
			$arrPL3['buland'] = (int)$ImmoDS->Value('immo_buland');
			$arrPL3['land'] = (int)$ImmoDS->Value('immo_land'); // DEU
			$t = $ImmoDS->Value('immo_etage');
			if($t== (int) $ImmoDS->Value('immo_etage') && $t > 0) {
				$arrPL3['etage'] = $t;
			} else {
				$arrPL3['etage'] = "";
			}
			$arrPL3['regionaler_zusatz'] = "";
			$immo_ds.= get_geo_OI($arrPL3);

			// kontaktperson
			$arrPL4['email_direkt'] = $ImmoDS->Value('email');
			$arrPL4['tel_zentrale'] = $ImmoDS->Value('tel');
			$arrPL4['tel_fax'] = $ImmoDS->Value('fax');
			$arrPL4['tel_handy'] = $ImmoDS->Value('mobil');

			$t = $ImmoDS->Value('ansprechpartner');
			$arr_ansprechpartner = explode_ansprechpartner($t);
			$arrPL4['name'] = $arr_ansprechpartner[1];
			$arrPL4['vorname'] = $arr_ansprechpartner[0];

			$t = $ImmoDS->Value('anrede');
			$arr_anrde_titel = explode_anrede($t);
			$arrPL4['titel'] = $arr_anrde_titel[1];
			$arrPL4['anrede'] = $arr_anrde_titel[0];
			$arrPL4['firma'] = "";
			$arrPL4['zusatzfeld'] = $ImmoDS->Value('ortsteil');
			$arrPL4['strasse'] = $ImmoDS->Value('adresse');
			$arrPL4['hausnummer'] = $ImmoDS->Value('hausnummer');
			$arrPL4['plz'] = $ImmoDS->Value('plz');
			$arrPL4['ort'] = $ImmoDS->Value('ort');
			$arrPL4['land'] = "";					// land
			$arrPL4['url'] = $ImmoDS->Value('internet');
			$immo_ds.= get_kontaktperson_OI($arrPL4);

			// preise
			$arrPL5['kaufpreis'] = $ImmoDS->Value('immo_kaufpreis');
			$arrPL5['kaltmiete'] = $ImmoDS->Value('immo_km'); //kaltmiete
			$arrPL5['nebenkosten'] = $ImmoDS->Value('immo_nk'); //nebenkosten
			$arrPL5['hausgeld'] = $ImmoDS->Value('immo_hausgeld');
			$arrPL5['mieteinnahmen_ist'] = $ImmoDS->Value('immo_mieteinnahme');
			$arrPL5['waehrung'] = $ImmoDS->Value('waehrung'); // EUR
			$arrPL5['betriebskosten'] = $ImmoDS->Value('betriebskosten'); // betriebskosten
			if ($ImmoDS->Value('courtageart' == "innen")) {
				$arrPL5['innen_courtage'] = $ImmoDS->Value('courtage'); // Courtage
			} else {
				$arrPL5['aussen_courtage'] = $ImmoDS->Value('courtage'); // Courtage
			}
			$immo_ds.= get_preise_OI($arrPL5);


			// anzahlzimmer
			$t = (int) $ImmoDS->Value('immo_anzzimmer');
			switch ($t) {
				case 1 : $zimmeranzahl = "1"; break;
				case 2 : $zimmeranzahl = "1,5"; break;
				case 3 : $zimmeranzahl = "2"; break;
				case 4 : $zimmeranzahl = "2,5"; break;
				case 5 : $zimmeranzahl = "3"; break;
				case 6 : $zimmeranzahl = "3,5"; break;
				case 7 : $zimmeranzahl = "4"; break;
				case 8 : $zimmeranzahl = "4,5"; break;
				case 9 : $zimmeranzahl = "5"; break;
				case 10: $zimmeranzahl = "5,5"; break;
				default : $zimmeranzahl = ""; break;
			}
			$arrPL6['anzahl_zimmer'] = "";

			// flaechen $ImmoDS->Value('immo_objektart')
			$arrPL6['wohnflaeche'] = "";
			$arrPL6['nutzflaeche'] = "";
			$arrPL6['ladenflaeche'] = "";
			$arrPL6['lagerflaeche'] = "";
			$arrPL6['bueroflaeche'] = "";
			$arrPL6['grundstuecksflaeche'] = "";
			$objekart = substr($objektart,0,1); // (1-C) hex aus z.B. A9
			$t = $ImmoDS->Value('immo_wohnflaeche') OR $ImmoDS->Value('immo_qm'); // quadratmeter
			switch ($objekart) {
				case 1 : //Zimmer;
				case 2 : //Wohnung;
				case 3 : //Haus;
					$arrPL6['wohnflaeche'] = $t;
					$arrPL6['anzahl_zimmer'] = $zimmeranzahl;
					break;
				case 4 : //Grundstueck;
					$arrPL6['grundstuecksflaeche'] = $ImmoDS->Value('immo_grundstueck');
					break;
				case 5 : //Buero Praxen;
					$arrPL6['bueroflaeche'] = $t;
					$arrPL6['anzahl_zimmer'] = $zimmeranzahl;
					break;
				case 6 : //Einzelhandel;
					$arrPL6['ladenflaeche'] = $t;
					break;
				case 7 : //Gastgewerbe;
					$arrPL6['nutzflaeche'] = $t;
					break;
				case 8 : //Hallen Lager Produktion;
					$arrPL6['lagerflaeche'] = $t;
					$arrPL6['nutzflaeche'] = $t;
					break;
				case 9 : //Land- und Forstwirtschaft;
					$arrPL6['grundstuecksflaeche'] = $ImmoDS->Value('immo_grundfstueck');
					break;
				case 'A' : //sonstige;
					$arrPL6['nutzflaeche'] = $t;
					break;
				case 'B' : //Freizeitimmobilie gewerblich;
					$arrPL6['grundstuecksflaeche'] = $ImmoDS->Value('immo_grundfstueck');
					break;
				case 'C' : //Zinshaus Renditeobjekt;
					$arrPL6['grundstuecksflaeche'] = $ImmoDS->Value('immo_grundflaeche');
					$arrPL6['nutzflaeche'] = $t;
					$arrPL6['anzahl_zimmer'] = $zimmeranzahl;
					break;
				default :
					// NOP
					break;
			}
			$immo_ds.= get_fleachen_OI($arrPL6);

			// zustand_angaben
			$arrPL7['baujahr'] = $ImmoDS->Value('immo_baujahr'); //"YYYY"
			$arrPL7['zustand'] = (int) $ImmoDS->Value('immo_zustand'); //"0-13"
			$arrPL7['alter'] = $ImmoDS->Value('immo_alter'); //"(0-2)"
			$arrPL7['bebaubar'] = $ImmoDS->Value('immo_bebaubar'); //"(0-5)"
			$arrPL7['erschliessung'] = $ImmoDS->Value('immo_erschliessung'); //"(0-3)"
			$immo_ds.= get_zustand_angaben_OI($arrPL7);

			// freitexte
			$arrPL8['objekttitel'] = Encoder($ImmoDS->Value('firma'));
			$arrPL8['dreizeiler'] = Encoder($ImmoDS->Value('branche'));
			$arrPL8['lage'] = Encoder($ImmoDS->Value('immo_lage'));
			$t = "";
			$a = $ImmoDS->Value('anfrage1');
			if (strlen($a)) {$t.= Encoder($a);}
			$a = $ImmoDS->Value('anfrage2');
			if (strlen($a)) {$t.= "\n\t".Encoder($a);}
			$a = $ImmoDS->Value('anfrage3');
			if (strlen($a)) {$t.= "\n\t".Encoder($a);}
			$a = "";
			$arrPL8['objektbeschreibung'] = strip_tags($t);

			$arrPL12['wert1'] = $ImmoDS->Value('klick1');
			$arrPL12['wert2'] = $ImmoDS->Value('klick2');
			$arrPL12['wert3'] = $ImmoDS->Value('klick3');
			$arrPL12['wert4'] = $ImmoDS->Value('klick4');
			$arrPL12['wert5'] = $ImmoDS->Value('klick5');
			$arrPL12['wert6'] = $ImmoDS->Value('klick6');
			$arrPL12['wert7'] = $ImmoDS->Value('klick7');
			$arrPL12['wert8'] = $ImmoDS->Value('klick8');
			$arrPL12['wert9'] = $ImmoDS->Value('klick10');
			$arrPL12['wert10'] = $ImmoDS->Value('klick');
			$arrPL12['kontaktID'] = $ImmoDS->Value('kontaktID');
			$arrPL12['ai_database'] = $ai_database;
			$t = get_vorhande_eigenschaften ($arrPL12); //klick1-10
			$arrPL8['sonstige_angaben'] = strip_tags($t);
			$t="";

			$immo_ds.= get_freitexte_OI($arrPL8);

			// anhaenge
			$pfad = "http://".$_SERVER["HTTP_HOST"]."/";
			$pfad.= $aiyootaID."/Uploaded/Firmen/";
			for ($xx=1;$xx<=20;$xx++) {
				$t= strip_tags($ImmoDS->Value('bild'.$xx));
				strlen($t)? $arrPL9['pfad'.$xx]= $pfad.str_replace("|","%7C",$t):$t="";
			}
			$immo_ds.= get_anhaenge_OI($arrPL9);
			
			// ausstattung
			$arrPL13['anzahl_balkon_terrassen'] = $ImmoDS->Value("anzahl_balkon_terrassen");
			$arrPL13['ausricht_balkon_terrasse'] = $ImmoDS->Value("ausricht_balkon_terrasse");
			$arrPL13['balkon_terrasse_flaeche'] = $ImmoDS->Value("balkon_terrasse_flaeche");
			$arrPL13['stellplatzart'] = $ImmoDS->Value("stellplatzart");
			$arrPL13['stellplatzmiete'] = $ImmoDS->Value("stellplatzmiete");
			$arrPL13['stellplatzkauf'] = $ImmoDS->Value("stellplatzkauf");
			$arrPL13['stellplatzanzahl'] = $ImmoDS->Value("stellplatzanzahl");
			$arrPL13['gartenflaeche'] = $ImmoDS->Value("gartenflaeche");
			$arrPL13['gartennutzung'] = $ImmoDS->Value("gartennutzung");
			$arrPL13['kueche_ebk'] = $ImmoDS->Value("kueche_ebk");
			$arrPL13['kueche_offen'] = $ImmoDS->Value("kueche_offen");
			$arrPL13['kamin'] = $ImmoDS->Value("kamin");
			$immo_ds.= get_ausstattung_OI($arrPL13);
			
			// verwaltung_objekt
			$t = $ImmoDS->Value('immo_verfuegbar_ab'); // dd.mm.yyyy
			$muster ="/^[\d]{2}\.[\d]{2}\.[\d]{4}$/";
			if (preg_match($muster, $t)) {
				$t = explode(".", $t);
				$t = $t[2]."-".$t[1]."-".$t[0];
			} else {
				$t = "";
			}
			$arrPL10['verfuegbar_ab'] = $t; //date("Y-m-d", time());

			switch ($ImmoDS->Value('immo_vermietet')) {
				case 1 : $arrPL10['vermietet'] = "1"; break; //vermietet
				case 2 : $arrPL10['vermietet'] = "2"; break; //unvermietet
				default : $arrPL10['vermietet'] = ""; break; //k.A.-Fall
			}
			$immo_ds.= get_verwaltung_objekt_OI($arrPL10);

			// verwaltung_techn
			$arrPL11['objektnr_intern'] = $ImmoDS->Value('ID');
			$arrPL11['objektnr_extern'] = $ImmoDS->Value('ID');
			$arrPL11['openimmo_obid'] = $ImmoDS->Value('ID');
			$arrPL11['stand_vom'] = date("Y-m-d", time());
			$immo_ds.= get_verwaltung_techn_OI($arrPL11);
			$ImmoDS->MoveNext();
			$xmlseite.= $immo_ds;
		}
		$xmlseite.= get_xmlseitenfuss_OI();
		break;
 	case 2 : // IS24-Format Teilmenge (XML nicht CSV)
// 	die("Programm beendet: Der Export zu ImmoScout24 ist noch nicht verfuegbar.");
 		$xmlseite = get_xmlseitenkopf_IS24($arrPL1);
		$ImmoDS->MoveFirst();
		$zaehler = 0;
		while ( $zaehler < 5 && !$ImmoDS->EOF()) {
			$zaehler ++;

/*
WohnungMiete
WohnungKauf
HausMiete
HausKauf
WAZ
BueroPraxis
Einzelhandel
Gastronomie
HalleProduktion
SonstigeGewerbe
GrundstueckWohnenKauf
GrundstueckWohnenMiete
GrundstueckGewerbe
GarageKauf
GarageMiete
-TypenHaus-


			AnbieterObjektID="0815"
			Ueberschrift="Sch&ouml;ne Wohnung"
			Importmodus="importieren"
			Wohnflaeche="100.00"
			Zimmer="4.00"
			Adressdruck="true"
			AnzahlBadezimmer="2"
			AnzahlSchlafzimmer="2"
			Aufzug="true"
			BalkonTerrasse="true"
			Baujahr="1869"
			BetreutesWohnen="true"
			Einbaukueche="true"
			Etage="2"
			Etagenzahl="6"
			Foerderung="true"
			FreiAb="sofort"
			GartenBenutzung="true"
			GruppierungsID="1"
			Haustiere="nachVereinbarung"
			Heizungsart="Zentralheizung"
			Nutzflaeche="22"
			Objektzustand="Gepflegt"
			Parkplatz="true"
			Provision="3.8% zzg. 16%MSt"
			Rollstuhlgerecht="true"
			StatusHP="aktiv"
			StatusIS24="aktiv"
			StatusVBM="aktiv"
			Waehrung="EUR"
			WohnungKategorie="Etagenwohnung"

AnbieterObjektID="WHG-MIETE"
Ueberschrift="WHG-MIETE" Wohnflaeche="30"
Zimmer="3.0"
Adressdruck="false"
Aufzug="true"
BalkonTerrasse="true"
Provisionspflichtig="true"
Provision="2,2 MM"
WazKategorie="Appartment"
FreiAb="2005-03-23
Gesamtflaeche="5674"
Verkaufsflaeche="5373"
LagerProduktionsFlaeche="23434"
VermietbareFlaeche="34356"
Kaufpreis="6536363763"
GrundstuecksFlaeche="1234"
*/




?>
<!-- WohnungMiete AnbieterObjektID="WHG-MIETE" Ueberschrift="WHG-MIETE" Wohnflaeche="30" Zimmer="3.0" Adressdruck="false" Aufzug="true" BalkonTerrasse="true" Provisionspflichtig="true" Provision="2,2 MM"

		WohnungMiete -->
<?

			// IS24-Immotyp aus OpenImmo-Daten ermitteln
			$arrPL2['nutzungsart'] = $ImmoDS->Value('immo_nutzungsart'); // 1 = WOHNEN ...
			$arrPL2['vermarktungsart'] = $ImmoDS->Value('immo_vermarktungsart');	// 1 = KAUF ...
			$objektart = $ImmoDS->Value('immo_objektart');
			$arrPL2['objektart'] = $objektart;	// hexdez 318 STRANDHAUS
			$arrPL2a['AnbieterObjektID'] = $ImmoDS->Value('');
			$arrPL2a['Ueberschrift'] = $ImmoDS->Value('');
			$immotyp = get_Immotyp_IS24($arrPL2);
			switch ($immotyp) {
			case 'WohnungMiete' : ;
				$arrPL2a['Wohnflaeche'] = $ImmoDS->Value('');
				$arrPL2a['Zimmer'] = $ImmoDS->Value('');
				break;
			case 'WohnungKauf' :
				$arrPL2a['Wohnflaeche'] = $ImmoDS->Value('');
				$arrPL2a['Zimmer'] = $ImmoDS->Value('');
				$arrPL2a['Baujahr'] = $ImmoDS->Value('');
				break;
			case 'HausMiete' :
				$arrPL2a['Wohnflaeche'] = $ImmoDS->Value('');
				$arrPL2a['Zimmer'] = $ImmoDS->Value('');
				$arrPL2a['Baujahr'] = $ImmoDS->Value('');
				break;
			case 'HausKauf' :
				$arrPL2a['Wohnflaeche'] = $ImmoDS->Value('');
				$arrPL2a['Zimmer'] = $ImmoDS->Value('');
				$arrPL2a['Baujahr'] = $ImmoDS->Value('');
				break;
			case 'WAZ' :
				$arrPL2a['WazKategorie'] = $ImmoDS->Value('');
				$arrPL2a['Wohnflaeche'] = $ImmoDS->Value('');
				$arrPL2a['Zimmer'] = $ImmoDS->Value('');
				$arrPL2a['FreiAb'] = $ImmoDS->Value('');
				break;
			case 'BueroPraxis' :
				$arrPL2a['BueroPraxisFlaeche'] = $ImmoDS->Value('');
				$arrPL2a['Baujahr'] = $ImmoDS->Value('');
				break;
			case 'Einzelhandel' :
				$arrPL2a['Verkausflaeche'] = $ImmoDS->Value('');
				$arrPL2a['Baujahr'] = $ImmoDS->Value('');
				break;
			case 'Gastronomie' :
				$arrPL2a['Gastraumflaeche'] = $ImmoDS->Value('');
				$arrPL2a['Objektkategorie2'] = $ImmoDS->Value('');
				$arrPL2a['Baujahr'] = $ImmoDS->Value('');
				break;
			case 'HalleProduktion' :
				$arrPL2a['LagerProdunktionsFlaeche'] = $ImmoDS->Value('');
				$arrPL2a['Baujahr'] = $ImmoDS->Value('');
				break;
			case 'SonstigeGewerbe' :
				$arrPL2a['Objektkategorie2'] = $ImmoDS->Value('');
				$arrPL2a['Hauptflaeche'] = $ImmoDS->Value('');
				$arrPL2a['Baujahr'] = $ImmoDS->Value('');
				break;
			case 'Grundstueck' :
				$arrPL2a['Grundstuecksflaeche'] = $ImmoDS->Value('');
				$arrPL2a['Baujahr'] = "";
				break;
			case 'GrundstueckWohnenKauf' :
				$arrPL2a['Grundstuecksflaeche'] = $ImmoDS->Value('');
				$arrPL2a['Baujahr'] = "";
				break;
			case 'GrundstueckWohnenMiete' :
				$arrPL2a['Grundstuecksflaeche'] = $ImmoDS->Value('');
				$arrPL2a['Baujahr'] = "";
				break;
			case 'GrundstueckGewerbe' :
				$arrPL2a['Grundstuecksflaeche'] = $ImmoDS->Value('');
				$arrPL2a['Baujahr'] = "";
				break;
			case 'GarageKauf' :
				$arrPL2a['Flaeche'] = $ImmoDS->Value('');
				$arrPL2a['Baujahr'] = $ImmoDS->Value('');
				break;
			case 'GarageMiete' :
				$arrPL2a['Flaeche'] = $ImmoDS->Value('');
				$arrPL2a['Baujahr'] = $ImmoDS->Value('');
				break;
			//laesst sich nicht extrairen// case 'TypenHaus' : ; break;
			default:
				$ImmoDS->MoveNext();
				continue;
				break;
			}
			$immo_ds = "<".$immotyp."\n";
			$immo_ds.= get_immotypattribute_IS24($arrPL2a).">\n";


			// Adresse der Immobilie
			$arrPL3['plz'] = strip_tags($ImmoDS->Value('immo_plz'));
			$arrPL3['ort'] = strip_tags($ImmoDS->Value('immo_ort'));
			$arrPL3['str'] = strip_tags($ImmoDS->Value('immo_str'));
			$arrPL3['hnr'] = strip_tags($ImmoDS->Value('immo_hnr'));
			//$arrPL3['buland'] = (int)$ImmoDS->Value('immo_buland');
			$arrPL3['land'] = (int)$ImmoDS->Value('immo_land'); // DEU
//			$t = $ImmoDS->Value('immo_etage');
// 			if($t== (int) $ImmoDS->Value('immo_etage')) {
// 				$arrPL3['etage'] = $t;
// 			} else {
// 				$arrPL3['etage'] = "";
// 			}
			$arrPL3['regionaler_zusatz'] = "";
			$immo_ds.= get_Objektadresse_IS24($arrPL3);

			// kontaktperson
			$arrPL4['email_direkt'] = $ImmoDS->Value('email');
			$arrPL4['tel_zentrale'] = $ImmoDS->Value('tel');
			$arrPL4['tel_fax'] = $ImmoDS->Value('fax');
			$arrPL4['tel_handy'] = $ImmoDS->Value('mobil');

			$t = $ImmoDS->Value('ansprechpartner');
			$arr_ansprechpartner = explode_ansprechpartner($t);
			$arrPL4['name'] = $arr_ansprechpartner[1];
			$arrPL4['vorname'] = $arr_ansprechpartner[0];

			$t = $ImmoDS->Value('anrede');
			$arr_anrde_titel = explode_anrede($t);
			$arrPL4['titel'] = $arr_anrde_titel[1];
			$arrPL4['anrede'] = $arr_anrde_titel[0];
			$arrPL4['firma'] = "";
			$arrPL4['zusatzfeld'] = $ImmoDS->Value('ortsteil');
			$arrPL4['strasse'] = $ImmoDS->Value('adresse');
			$arrPL4['hausnummer'] = $ImmoDS->Value('hausnummer');
			$arrPL4['plz'] = $ImmoDS->Value('plz');
			$arrPL4['ort'] = $ImmoDS->Value('ort');
			$arrPL4['land'] = "";					// land
			$arrPL4['url'] = $ImmoDS->Value('internet');
			$immo_ds.= get_Kontaktperson_IS24($arrPL4);

			$immo_ds.= "\n</".$immotyp.">\n";
		 	$immo_ds.= get_SonstigeAngaben_IS24();
		 	$immo_ds.= get_MultimediaAnhang_IS24();
		 	$immo_ds.= get_preise_IS24();
			$ImmoDS->MoveNext();
			$xmlseite.= $immo_ds;
		}
		$xmlseite.= get_xmlseitenfuss_IS24();
		break;
	default : die("Es gibt keine Eintr&auml;ge zum Exportieren");
		break;
}

//Ergebis ausgeben
$ausgabe = utf8_encode($xmlseite); unset($xmlseite);
switch ($arrPL1['ausgabeart']) {
	case 1 : // Browser
		header('Content-Type: text/html; charset=utf-8');
		echo $ausgabe;
		break;
	case 2 : // Download
		header('Content-Type: application/octet-stream');
		$filename = $arrPL1["filename"];
		header('Content-Disposition: attachment; //filename="'.$arrPL1["filename"].'"');
		echo $ausgabe;
		break;
	case 3 : // FTP-Upload
		switch ($zielportal) {
			case 1: // ImmoNet
				$bool = ftp_upload ($arrPL1, $ausgabe);
				if ($bool) {
					echo "FTP-Upload zu ImmoNet erfolgreich";
				} else {
					echo "FTP-Upload zu ImmoNet misslungen";
				}
				break;
			case 2: // IS24
				die("FTP-Upload zu Scout24 wird noch nicht unterstuetzt.");
				break;
			/*
			case 3: // XYZ
				die("FTP-Upload zu XYZ wird noch nicht unterstuetzt.");
				break;
			case 4: // XYZ
				die("FTP-Upload zu XYZ wird noch nicht unterstuetzt.");
				break;
			case 5: // XYZ
				die("FTP-Upload zu XYZ wird noch nicht unterstuetzt.");
				break;
			*/
			default:
					die("Portal wird nicht unterstuetzt");
				break;
		}
		break;
	default : //
		die("Fehler bei der Ergebnisausgabe");
		break;
}
//$zzb = microtime();
//echo "T2: ".($zzb);
//echo "T1: ".($zza);
//echo "dT: ".($zzb-$zza);
?>
