<?php
/*
 * API operation getTransactionResult
 *
 * Using this operation, you can obtain the result of a transaction once the customer has
 * completed the order in the BillSAFE Payment Gateway and has been redirected to your
 * shop. Depending on the result (field "status"), you present the customer with a concluding
 * order confirmation or offer them alternative payment methods.
 * In addition to the user-defined fields ("custom_{n}"), the response also includes the
 * customer data, some of which might have been updated.
 */

//The following array contains the names of all possible request parameters
//that can/must be specified with the API operation getTransactionResult
$paramNames = array(
    //Alphanumeric / length: 26 characters
    //Token value, which you already received previously as return value of operation prepareOrder.
    'token',
);

$params = array();

//fill params array with all posted values
foreach($paramNames as $paramName)
{
    if (!empty($_REQUEST[$paramName]))
    {
        $params[$paramName] = $_REQUEST[$paramName];
    }
}

//instantiate Billafe Sdk with settings stored in the file billsafe_ini.php

//call Sdk method 'callMethod' with parameters method name and all other parameters (array)
$response = $bs->callMethod('getTransactionResult', $params);

//The response always includes element "ack" (= acknowledgment / receipt confirmation),
//which can assume value "OK" or "ERROR".
//- "OK" means that the operation has been executed successfully. Depending on the
//  operation, the response will include further elements.
//- "ERROR" means that the operation could not be executed. In that case, the
//  response will include element "errorList" with one or several error elements
if ($response->ack == 'OK') {
    //Status of the transaction. Possible values:
    //- "ACCEPTED": BillSAFE has accepted the transaction
    //- "DECLINED": BillSAFE has rejected the transaction
//    Status: <?php echo $response->status;

    if (isset($response->declineReason))
    {
		//Whole number / max. length: 5 characters / only if: status = DECLINED
		//Identification of the reason why the transaction was rejected.
//		echo $response->declineReason->code;

		//Alphanumeric / max. length: 100 characters / available if: status = DECLINED
		//Reason why the transaction was rejected. This information must not be displayed to
		//the customer.
//		echo $response->declineReason->message;

		//Alphanumeric / max. length: 250 characters / available if: status = DECLINED
		//Reason why the transaction was rejected. This information should be displayed
		//to the customer.
		$fehlercode = $response->declineReason->buyerMessage;

		$Location = "http://".host;
		if ($KorbGrund->Value("ssldomain") != "") $Location = $KorbGrund->Value("ssldomain");
		header('Location:'.$Location.'/cms/frontend/shopbestell.php?sprache='.$_REQUEST["sprache"].'&naviID=0&ueber=0&myaiyootaID='.$aiyootaID.'&wmxkunde='.$wmxKundenID.'&fehler=billsafe&fehlercode='.urlencode($fehlercode));
		die();
    }

    //Alphanumeric / max. length: 50 characters / available if: status = ACCEPTED
    //Unique ID for the transaction accepted by BillSAFE. The transactionId is required
    //for subsequent operations, such as the shipping notification (reportShipment) or
    //to notify returns / credit notes / cancellations (updateArticleList).
    if (isset($response->transactionId))
    {
        mysql_query("UPDATE `wk_kunden` SET billsafe_transactionID = '".$response->transactionId."' WHERE aiyootaID = '".$aiyootaID."' and warenkorbID = '" . $wmxKundenID . "';");
        
        $billsafe_transactionID = $response->transactionId;

        if (!isset($_SESSION['transactions']))
        {
            $_SESSION['transactions'] = array();
        }

        if (isset($_SESSION['prepareOrderData'][$params['token']]))
        {
            $_SESSION['transactions'][$response->transactionId] = $_SESSION['prepareOrderData'][$params['token']];
            unset($_SESSION['prepareOrderData'][$params['token']]);
        }
    }
}
else
{
    //If an operation could not be executed successfully, the "ack" element included in the
    //response will contain the value "ERROR". In addition, one or several error messages
    //consisting of an error code and an error description will be output.
    $errors = $response->errorList;
	
	$fehlercode = "";
    foreach($errors as $error)
    {
        //Error codes consist of a three-digit numerical value. See BillSAFE Integration Guide
        //for a list of the most important error codes.
        $fehlercode .= $error->code . ' ' . $error->message . '<br/>';
    }
    
    $Location = "http://".host;
    if ($KorbGrund->Value("ssldomain") != "") $Location = $KorbGrund->Value("ssldomain");
    header('Location:'.$Location.'/cms/frontend/shopbestell.php?sprache='.$_REQUEST["sprache"].'&naviID=0&ueber=0&myaiyootaID='.$aiyootaID.'&wmxkunde='.$wmxKundenID.'&fehler=billsafe&fehlercode='.urlencode($fehlercode));
    die();
}
?>