<?
$genderplus = "";
//$genderplus = "KlarnaFlags::";
if ($Kunde->Value("anrede") == "MALE") $gendertxt = $genderplus."m";
if ($Kunde->Value("anrede") == "FEMALE") $gendertxt = $genderplus."f";

/**
 * 3.
 * Edit the billsafe_ini.php file which was shipped with the SDK and insert your
 * API credentials etc. Leave "isLiveMode" set to false whilst you are developing
 * and testing your application! Only set this value to true after everything is
 * working in sandbox-mode and BillSAFE has explicitly approved your application.
 * Make sure to update the "applicationVersion" value every time you release a
 * new version of your application. This helps BillSAFE to localize errors
 * that might occur only in specific releases. BillSAFE recommends to include
 * a release number as well as a release date, e.g. "v.1.2 beta (2010-12-29)".
 *
 * 4.
 * Create a Billsafe_Sdk object. Optionally you may provide the path to the
 * billsafe_ini.php file in the constructor. If you omit it, the default
 * billsafe_ini.php file located in the sdk folder will be used.
 */
ini_set('include_path', ini_get('include_path') . PATH_SEPARATOR . '/cms/frontend/Billsafe');
require 'Billsafe/Sdk.php';

$ini['isLiveMode'] = true;

//Set this to true if your data is utf-8 encoded.
//Set this to false if your data is latin-1 encoded.
//The encoding of the response object will be affected accordingly.
$ini['isUtf8Mode'] = false;

//API version
$ini['apiVersion'] = 208;

//Payment Gateway version
$ini['gatewayVersion'] = 200;

/**
 * If you do not want to make use of the billsafe_ini.php file, you may
 * alternatively stick your API credentials into setCredentials().
 */
$bs = new Billsafe_Sdk();
$bs->setCredentials(array(
    'merchantId'             => $KorbGrund->Value("billsafe_VID"),
    'merchantLicenseSandbox' => $KorbGrund->Value("billsafe_lizenz"),
    'merchantLicenseLive'    => $KorbGrund->Value("billsafe_lizenz"),
    'applicationSignature'   => 'b3f9ce33ffc8b8351c933ce998357473',
    'applicationVersion'     => 'v1.7 beta (2010-12-31)'));

/**
 * To see what information is sent to the BillSAFE API server and what the
 * response looks like, you can inject a logger object. This might be useful
 * for debugging during development. You can either provide your own logger
 * class (which must implement the interface Billsafe_Logger) or use one of the
 * Billsafe_LoggerXXX classes that come with the SDK.
 */
//require 'Billsafe/LoggerEcho.php';
//$bs->setLogger(new Billsafe_LoggerEcho());

require 'Billsafe/LoggerFile.php';

$bs->setLogger(new Billsafe_LoggerFile('../../'.$aiyootaID.'/Uploaded/dat/BillSafe.log'));

#require 'Billsafe/LoggerMail.php';
#$bs->setLogger(new Billsafe_LoggerMail('you@your-shop.com'));

/**
 * 5.
 * To invoke an API method simply use the callMethod() function which requires
 * two arguments.
 *   1. The name of the API method to invoke
 *   2. An array or object containing the parameters for that API method
 * The API parameters can be specified in various ways. The simplest but
 * probably not the most convenient way is to specify the parameters exactly
 * as mentioned in the "BillSAFE Integration Guide". Here is an example for
 * the prepareOrder() API method:
 */
include("Billsafe/params.php");

$response = $bs->callMethod('prepareOrder', $params);

//var_dump($response);
$token = $response->token;
// mysql_query("UPDATE `wk_kunden` SET token = '".$token."' where aiyootaID = '".$aiyootaID."' and  and warenkorbID = '" . $wmxKundenID . "';");
//echo "<br>token: ".$token;
//die();

//die();

/**
 * 6.
 * callMethod() returns a stdClass which contains the API response in a
 * structured manner. The output of the above var_dump($response) looks
 * like this:
 *
 * object(stdClass)#1 (2) {
 *    ["ack"]=>
 *    string(2) "OK"
 *    ["token"]=>
 *    string(26) "4d2db2648e7155d2db2648e7ef"
 *  }
 *
 * In case an error occurred, the output would look something like this:
 *
 * object(stdClass)#1 (2) {
 *   ["ack"]=>
 *   string(5) "ERROR"
 *   ["errorList"]=>
 *   array(1) {
 *     [0]=>
 *     object(stdClass)#2 (2) {
 *       ["code"]=>
 *       string(3) "215"
 *       ["message"]=>
 *       string(30) "Parameters of customer missing"
 *     }
 *   }
 * }
 *
 * The "BillSAFE Integration Guide" describes the responses of API
 * methods without considering the hierachy. For example the
 * getTransactionResult API method is described as returning the
 * following elements:
 *
 * - status
 * - declineReason_code
 * - declineReason_message
 * - transactionId
 * - customer_gender
 * - customer_firstname
 * - customer_lastname
 * - customer_street
 * - customer_houseNumber
 * - customer_postcode
 * - customer_city
 * - customer_country
 * - customer_dateOfBirth
 * - customer_email
 * - customer_phone
 * - custom_{n}
 *
 * However the SDK converts the flat elements back into the intended
 * structure by interpreting the underscores as separators of the
 * hierarchy levels. Therefore a var_dump() of the response of the
 * getTransactionResult API method will look something like this:
 *
 * object(stdClass)#1 (2) {
 *   ["ack"]=>
 *   string(5) "OK"
 *   ["status"]=>
 *   string(8) "ACCEPTED"
 *   ["transactionId"]=>
 *   string(10) "9876543210"
 *   ["customer"]=>
 *   object(stdClass)#2 (11) {
 *     ["gender"]=>
 *     string(1) "m"
 *     ["firstname"]=>
 *     string(3) "Max"
 *     ["lastname"]=>
 *     string(10) "Mustermann"
 *     ["street"]=>
 *     string(9) "Musterweg"
 *     ["houseNumber"]=>
 *     string(4) "12 a"
 *     ["postcode"]=>
 *     string(5) "12345"
 *     ["city"]=>
 *     string(11) "Musterstadt"
 *     ["country"]=>
 *     string(2) "DE"
 *     ["dateOfBirth"]=>
 *     string(10) "1982-12-31"
 *     ["email"]=>
 *     string(26) "max.mustermann@example.com"
 *     ["phone"]=>
 *     string(12) "0123/4567890"
 *   }
 *   ["custom"]=>
 *   array(3) {
 *     [0]=>
 *     string(19) "Benutzerdefiniert 1"
 *     [1]=>
 *     string(19) "Benutzerdefiniert 2"
 *     [2]=>
 *     string(19) "Benutzerdefiniert 3"
 *   }
 * }
 *
 * Note that the customer_XXX elements have become attributes of a
 * customer stdClass object and that custom_{n} has been transformed
 * into an array of strings.
 * The declineReason_XXX elements are not part of the response here,
 * since they are optional and depend on the "status" attribute.
 *
 *
 * A response always contains the attribute "ack" as an
 * acknowledgement status which is either "OK" or "ERROR".
 *
 * The following example shows how to check whether the API method was
 * executed successfully and how to print out any error message that might
 * have occurred.
 */
if ($response->ack == 'OK')
{
    echo "method was executed successfully!";
}
else
{
    echo "at least one error occurred! <br />\n";
    
    foreach ($response->errorList as $error)
    {
        echo "Error Code " . $error->code . " / " . $error->message . "<br />\n";
    }
}

/**
 * Please note that callMethod() might throw exceptions, e.g. if the network connection
 * could not be established. Therefore it's a good idea to put it inside a try/catch
 * block as shown in the next example. The example also demonstrates how the result of
 * a transaction can be retrieved using the token that has previously been returned by
 * prepareOrder:
 */
// try
// {
//     $params = array('token' => '4d2db2648e7155d2db2648e7ef');
//     
//     $response = $bs->callMethod('getTransactionResult', $params);
//     
//     if ($response->status == 'ACCEPTED')
//     {
//         //... store order etc.
//         
//         echo "BillSAFE has accepted the transaction. Thank you for your order!";
//     }
//     else 
//     {
//         echo "Currently BillSAFE cannot be chosen as a payment method. Please pick another one!";
//     }
// }
// catch (Billsafe_Exception $e)
// {
//     echo "an exception occurred! Message: " . $e->getMessage();
// 
//     //log exception, inform admin etc.
// }

/**
 * Apart from the callMethod function the SDK contains one convenience function
 * which performs an HTTP redirect onto the BillSAFE Payment Gateway. The redirection
 * is part of the payment workflow as described in the "BillSAFE Integration Guide".
 * Simply provide the token that was contained in the response of the prepareOrder
 * function.
 */
$bs->redirectToPaymentGateway($token);
?>
